﻿//Array Enhancements

/*
* sort
* sort items in the array.
*/
/*Array.prototype.sort = function()
{
	for(i=0;i<this .length;i++)
	{
		for(j=i+1;j<this.length;j++)
		{
			if(Number(this[i]) >Number(this[j]))
			{
				temp = this[j];
				this[j] = this[i];
				this[i] = temp;
			}
		}
	}
}*/

/*
* removeDuplicate
* remove dumplicate items in the array.
*/
Array.prototype.removeDuplicate = function()
{
	// Here we remove duplicate values from first array
	var array4 = new Array;
	for(var i=0; i<this.length; i++) 
	{
	      var xx = true;
		for(var j=i+1; j<this.length; j++)
		{
			if(this[i] == this[j])
				xx = false;		
		}	
		if(xx == true)
			array4.push(this[i]);
	}
	return array4;
}

Array.prototype.removeFrom = function(toberem)
{
	// Here we remove duplicate values from first array
	var array4 = new Array;
	for(var i=0; i<this.length; i++) 
	{
	      var xx = true;
		for(var j=0; j<toberem.length; j++)
		{
				if(this[i] == toberem[j])
				xx = false;		
		}	
		if(xx == true)
			array4.push(this[i]);
	}
	return array4;
}

/*
* SHUFFLE
* Randomizes the array.
*/
Array.prototype.shuffle = function()
{
  for (var i = 0; i < this.length; i++)
  {
    // Random item in this array.
    var r = parseInt(Math.random() * this.length);
    var obj = this[r];
 
    // Swap.
    this[r] = this[i];
    this[i] = obj;
  }
}

// Version 3.3
// Set by the XML file
var _sIntroPage; // intro page content
var _sIntroCustom = ""; // custom intro page
var _nRequiredCorrect = 0; // number of questions to pass
var _nID = 0; // the ID of this assessment
var _bAdaptive = true; // true if the test is adaptive

/* global variables */
var _nDebug = 1; /* set this to a number > 0 to show debug messages */
var _nSectionCurrent = 0; // the current section
var _nQuestionCurrent = 0;
var _nObjectives; // the total number of sections
var _nQuestions; // the total number of questions (all objectives)
var _nQuestionCount; //the current question # based on all questions.
var _aTotalQuestions = new Array(); //Array of question totals for each objective (idx)
var _aObjRequired;	 // array of required objectives for selected tracks
var _oQuestion = null; // the currently selected question object
var _dateStart = null; /* start date of this sesstion */
var _timeStart = null; /* start time of this sesstion */
var _bEmbedded = false; /* true if running as a stand alone SCO, else false */
var _timerTest = null; /* used to set a timer for the test */
var _timeLimitMS = 0; /* the time limit for the test in milliseconds */
var _bTimeLimitReached = false; /* true if the time limit was reached */
var _aOrder = null; // an array that will provide the order for the sections
var _aTestedOutOrder = null; // an array that will provide the order for all sections that have not been tested out of.
var _aQuestOrder = new Array(); //an array that will provide the order for the questions.
var _nPassingScore; // the passing percentage
var _nCorrect; // the number of questions answered correctly
var _nIncorrect; // the number of questions answered incorrectly
var _nAnswered; // the number of questions answered
var _nTotalScore = 0; // the score of this test
var _aObjState = new Array();
var _sSep1 = "::";  //Seperate Discrete Data on CYK 
var _sSep2 = "^^";	//Seperate Question Data on CYK 
var _sSep3 = "||";  //Seperates Section || Question data (pretest)
var _bSubmitWarning = false; // true if the submit warning is showing
var _sPassStatus = "I"; // the passing status, can be P | F | I
var _sReportedState = ""; // the last reported state
var _sRequired; // the requirement to pass
var _bWarnedFailed = false;
var _nPosttestAttempts = 0; // number of times user has taken the post test
var _bPosttestAttempted = false // set to true once the user has begun the post test
var _bPosttestReviewMode = false; // Indicates whether user is in review mode for the Post test. In review mode, no score or status is saved.
/* these global variables define how the test is delivered */
var mustAnswer = false;
var randomizeTest = false;
var randomizePool = false;
var randomizeChoices = false;
var numberAttempts = 1;
var questionsToShow = 0;
var timeLimit = 0;
var immediateFeedback = true;
var delayedFeedback = false;
var _bShowIntro = true; // show the introduction page
var _bAllowRetake = false; // true if the test should allow a retake

var _bAllowRetry = true; // allow a retry on a question
var _bShowBackLinks = true; // show a hyperlink to review
var _bShowResultsPage = false; // show a results page
var _bMustAnswerAll = false; // must answer all of the questions
var _bTestStarted = false; // boolean indicating whether the user has started the post test

// LOCALIZED STRINGS - the strings are defined in Language.xml in the Configuration folder
var XsRequired;
var XsSummaryPassed;
var XsSummaryFailed;

var XsRequiredMust;
var XsSummaryPassedMust;
var XsSummaryFailedMust;

// introduction
var XsIntro;
var XsIntroMust;
var XsIntroTestOut;
var XsIntroPreTest;

// summary messages for testout
var XsRequiredTestout;
var XsSummaryPassedTestout;
var XsSummaryFailedTestout;

//summary messages for pretest
var XsPretestObjMod;  //Tested out of Objectives and Modules
var XsPretestObjPage; //Tested out of Objectives and Pages


/*Scenario 1 - We have tested out of the course, but we haven't passed any objectives, or tested out of modules.*/
/*Scenario 2 - We have failed to test out, we haven't passed objectives, we haven't tested out of modules.*/	
/*Scenario 3 - We have tested out of the course, and we have passed objectives and tested out of modules.*/
/*Scenario 4 - We have failed to test out, but we pass objectives and test out of modules.*/	
/*Scenario 5 - We have tested out of the course, we have passed objectives, but haven't tested out of modules.*/
/*Scenario 6 - We have failed to tested out, we have passed objectives, but haven't tested out of modules.*/	
var XsPretestScene1Results;	
var XsPretestScene2Results;	
var XsPretestScene3Results;		
var XsPretestScene4Results;	
var XsPretestScene5Results;	
var XsPretestScene6Results;	
		

// Fail notification in the test out
var XsFailWarning;
var XsFailWarningILT;

var XsTimeoutAlert;

/* var buttons */
var XsNavPrev;
var XsNavNext;
var XsNavFirst;
var XsNavIntro;
var XsNavResults;

/* page number display */
var XsMsgPageNum;

/* too many attempts for this question */
var XsMsgTooMany;

/* time limit exceeded */
var XsMsgTimeout;

/* _bMustAnswerAll is true and not all questions are answered, tell the learner that he must come back to complete the test */
var XsMsgMustAnswerAll;

/* _bMustAnswerAll is false and not all questions are answered, ask learner if he is done with the test */
var XsMsgIncomplete;

/* title of the Question Item Menu */
var XsQitemTitle;

/* title of the test status */
var XsTestStatusTitle;

/* text of retake the test button */
var XsTestStatusRetake;

/* try another question */
var XsAnotherQuestion;
var XsAnotherQuestionLink;

/* review pre-text */
var XsReviewPreText;

/* correct/incorrect feedback*/
var XsFeedbackCorrect;
var XsFeedbackIncorrect;
var XsCorrectIs;

/* message to describe delayed feedback */
var XsMsgDelayed;

/* delayed response strings */
var XsMsgDelayedQuestion;
var XsMsgDelayedResponse;
var XsMsgDelayedCorrect;
var XsMsgDelayedResultTitle;
var XsMsgDelayedResultCorrect;
var XsMsgDelayedResultIncorrect;
var XsMsgDelayedFeedbackResponse;
var XsMsgDelayedFeedbackCorrect;

/* true false strings */
var XsMsgTrue;
var XsMsgFalse;

/* time display string */
var XsMsgTime;

/* user must supply an answer */
var XsMsgAnswerTF;
var XsMsgAnswerMC;
var XsMsgAnswerMCM;
var XsMsgAnswerFI;
var XsMsgAnswerM;

/* string for check answers button */
var XsMsgCheck;

// submit warning
var XsSubmitMessage;
var XsSubmitQuestion;

/* directions for a question */
var XsMsgDirectionsTF;
var XsMsgDirectionsMC;
var XsMsgDirectionsMCM;
var XsMsgDirectionsFI;
var XsMsgDirectionsFIM;

// intro page legend
var XsLegendLabel;
var XsLegendIncorrect;
var XsLegendCorrect;
var XsLegendVisited;
var XsLegendCurrent;
var XsLegendNotAttempted;
var XsLegendNotVisited;

// Define the question object - this is called as "new Question()" in JavaScript
// the type of question
// question - the question (or prompt) to present to the learner
// answer - the correct answer
// response - the learner's response to the question
// choice - an array of choices for true-false, multiple choice and matching
// list - an array of items used in matching
// feedback - an array of feedback used in multiple-choice single correct answer
// feedbackCorrect and feedbackIncorrect - used for feedback in all other questions
// attempts - the number of attempts on this question
// choiceRand - an array of randomized choices
// id - the ID of the question to report to SCORM
function Question() {
	// init the properties
	this.type = "";
	this.question = "";
	this.answer = "";
	this.response = "";
	this.choice = new Array();
	this.list = new Array();
	this.feedback = new Array();
	this.feedbackCorrect = "";
	this.feedbackIncorrect = "";
	this.attempts = 0;
	this.choiceRand = null;
	this.id = "";
}

// Define a section object. A test is a collection of one or more sections
// passed - true if the section has been passed
// feedbackPassed - feedback to deliver to the learner if the learner has a passing score for this section
// feedbackFailed - feedback to deliver to the learner if the learner has a failing score for this section
// pool - add array containing the pool of questions
// selected - the question selected from the pool, initialized to -1 to indicate no selection
// testedOut - indicates whether the objective that applies to this section has been tested out.
function Section() {
	// init the properties
	this.id;
	this.passed = false;
	this.feedbackPassed = "";
	this.feedbackFailed = "";
	this.pool = new Array();
	this.selected = -1;
	this.passingScore;  //minscore value from objectives.xml
	this.userScore;
	this.testedOut = "0";
}

// define the test array to hold the section objects
test = new Array();

/**********************
* Unique functions for running in stand-alone mode (non-embedded)
***********************/

/*********
* do all of the things required to initialize this session of the test
**********/
function initTest() {
	
	// reset the test started variable.
	_bTestStarted = false; 
	
	// read in the languages XML file
	loadLanguage();
	
	// eliminate the too many string
	XsMsgTooMany = "";

	// see if the assess XML has post-test in the name
	if(assessXML.toLowerCase().indexOf('post-test') > -1){
		// It does, set the in post-test flag to true
		parent._bPosttest = true;
		
		// set up the course interface for the post test
		parent.configurePostTestInterface();
		
		// see if this course is already complete i.e. the post test has been passed/tested out
		if(parent.isComplete() || parent.getCompletionStatus() == "failed")
			_bPosttestReviewMode = true; // If this post test has been previously completed, we are in review mode.
			
		// see if we are including Tested Out Objectives
		if(parent._bTestOut && parent._bPretest && !parent._sPT_RequirePassedObjectives){
			parent.initTestedOutPosttest();
		}
	}
	
	// read the questions from the XML document
	getQuestions();
	
	// see if we are including tested out of 
	if(parent._bTestOut && parent._bPretest && !parent._sPT_RequirePassedObjectives)
		initializeTestedOutQuestions();
		
	// see if we are are showing the testout
	if (!inMain(parent)) {
		//we are, are we in pretest (adaptive) mode
		if(parent._bPretest == true){
			//turn off retry for pretests
			_bAllowRetry = false;
			 
			// the passing score is set in definitions.js
			_nPassingScore =  parent._sMinTestOutScore;
			
			//use the test out message
			_sRequired = XsRequiredTestout;	
			// add the variable information to the required-to-pass string
			_sRequired = _sRequired.replace(/%%required/g,_nRequiredCorrect);
			_sRequired = _sRequired.replace(/%%total/g,_nQuestions);
		//we aren't, we are in a test out
		}else{
			//no we aren't in pretest mode calculate the passing score required as a percent of objectives
			_nPassingScore =  (_nRequiredCorrect * 100) / _nObjectives;

			// we are, use the test out message
			_sRequired = XsRequiredTestout;
		
			// add the variable information to the required-to-pass string
			_sRequired = _sRequired.replace(/%%required/g,_nRequiredCorrect);
			_sRequired = _sRequired.replace(/%%total/g,_nObjectives);
		}
	// see if we are in the post test
	}else if(parent._bPosttest){
		//turn off retry for posttests
		_bAllowRetry = false; 
		
		// the passing score is set in definitions.js
		_nPassingScore = parent._sPT_MinScore;

		// a knowledge check, see if all of the questions need to be answered
		if (_bMustAnswerAll) {
			// required
			_sRequired = XsRequiredMust;
		} else {
			_sRequired = XsRequired;
		}
		// add the variable information to the required-to-pass string
		_sRequired = _sRequired.replace(/%%required/g,_nRequiredCorrect);
		_sRequired = _sRequired.replace(/%%total/g,_nQuestions);
	//we are in the course
	} else {
		//calculate the passing score required as a percent
		_nPassingScore =  (_nRequiredCorrect * 100) / _nObjectives;
		
		// a knowledge check, see if all of the questions need to be answered
		if (_bMustAnswerAll) {
			// required
			_sRequired = XsRequiredMust;
		} else {
			_sRequired = XsRequired;
		}
	
		// add the variable information to the required-to-pass string
		_sRequired = _sRequired.replace(/%%required/g,_nRequiredCorrect);
		_sRequired = _sRequired.replace(/%%total/g,_nObjectives);
	}	

	// get the state information if we are not in a posttest that requires 
	if (parent.getKcState){
		// see if we are NOT in a post test, or we are in one that requires passed objectives
		if(!parent._bPosttest || (!parent._sPT_RequirePassedObjectives && parent._bTestOut && parent._bPretest)){
			var sState = parent.getKcState(_nID-1);
		}else
			// we are, so reset the state
			var sState = "";
	}else
		var sState = "";
	
	// reload attempts if we are in a post test
	if(parent._bPosttest){
		var sAttempts = parent.getState("PST",""+_nPosttestAttempts);
		if(sAttempts != "")
			_nPosttestAttempts = parseInt(sAttempts); 
	}
	
	// see if we got any state information
	if (sState != "") {
		if(!inMain(parent) && parent._bPretest){
			// we did, process the state data
			reloadPretestState(sState);
		}else if(parent._bPosttest){
			reloadPosttestState(sState);
		}else{
			// we did, process the state data
			reloadState(sState);	
		}
	} else {
		/* no SCORM API, establish the order of the sections */
		setOrder();
	}
	
	// see if we are in a Knowledge Check instead of the Test Out
	if (inMain(parent)) {
		// *** Need to reset the amount required correct because we have a pre test where objectives can be tested out
		// so user is not required to complete tested out questions.
		
		// see if this KC is the post test
		if(parent._bPosttest){
		
			// reset section to -1. We can only enter the post test from the beginning
			_nSectionCurrent = -1;
			// reset question nmber to -1. We can only enter a post test from the beginning
			_nQuestionCurrent = -1;
		
			// get the index of this Post Test
			var nPosttest = parent._nModTotal-1;
			var sRequiredMods = "";
			// see if user must complete all required modules and if this post test was answered before
			if (parent._bPT_MustCompleteModulesFirst) {
				// not answered, so we need to verify that all required mods have been completed
				
				// loop through the knowledge check array
				for (var i=0; i < nPosttest; i++) {
					// see if this knowledge check is passed AND the module is required
					if (parent._aKcState[i].substring(0,1) != "P" && parent._aModRequired[i]) {
						// it is not passed, see if we already have data in the list of incomplete modules
						if (sRequiredMods != "") {
							// we do, add a comma
							sRequiredMods += ", ";
						}
						
						// add the module number
						sRequiredMods += (i+1);
					}
				}
			}
			
			// See if the post test was tested out
			if(parent._aNodeStatus[_nID].sTestedOut == "1"){
				_sIntroPage = XsIntroPostTestTestedOut;
			// See if the course has already been completed and the completion resulted in a pass
			} else if(parent.isComplete() && !parent.getPassFail() == "failed"){
				_sIntroPage = XsIntroPostTestCompleted;
			// see if user has exhausted their attempts
			}else if(parent._sPT_MaxAttempts > 0 && _nPosttestAttempts >= parent._sPT_MaxAttempts){
				_sIntroPage = XsIntroPostTestNoAttempts;
			// if there are any required modules that have not been completed
			}else if(sRequiredMods != ""){
				_sIntroPage = XsIntroPostTestRequired;
				_sIntroPage = _sIntroPage.replace(/%%m/g,sRequiredMods);
			}else{
				_sIntroPage = XsIntroPostTest;
			}
		}else{
			// a knowledge check, see if all of the questions need to be answered
			if (_bMustAnswerAll) {
				// required
				_sRequired = XsRequiredMust;
				_sIntroPage = XsIntroMust;
			} else {
				_sRequired = XsRequired;
				_sIntroPage = XsIntro;
			}
		}
		
		// *** Reset the intro text
		
		// see if we need to show optional/required modules
		if (parent._bShowOptional) {
			// we do, get the module number
			var nMod = parent._sPageCurrent.substring(0,parent._sPageCurrent.indexOf("_")) - 1;
			
			// see which word to show
			if (parent._aModRequired[nMod]) {
				// required
				var sType = '';
			} else {
				// optional
				var sType = '<span class="pageOptional" title="' + parent._sOptionalExplanation + '"> (' + parent._sOptional + ')</span>';
			}
		} else {
			// none
			var sType = '';
		}
		
		if(parent._bPosttest){
			// initialize non-tested out question total
			var nNonTestedOutTotal = _nObjectives;
			// set the question total to the number of questions not tested out of
			nNonTestedOutTotal = getNonTestedOutQuestionTotal();
			// subtract the number of objectives already tested out from the amount needed to pass
			var nRequiredToPass = _nRequiredCorrect - (_nQuestions - nNonTestedOutTotal); // - (_nQuestions - nNonTestedOutTotal);	
			// see if the user has tested out of more than the required amount
			if(nRequiredToPass < 0)
				// they have, so they need to test out of 0 objectives.
				nRequiredToPass = 0;
			
			// add the variable information to the required-to-pass string
			_sRequired = _sRequired.replace(/%%required/g,nRequiredToPass);
			_sRequired = _sRequired.replace(/%%total/g,nNonTestedOutTotal);
			
			// build the complete intro string
			_sIntroPage = '<div class="levelOne">' + XsIntroPostTestTitle + '</div>' + _sIntroPage;
			_sIntroPage = _sIntroPage.replace(/%%x/g,nRequiredToPass);
			_sIntroPage = _sIntroPage.replace(/%%y/g,nNonTestedOutTotal);
			_sIntroPage = _sIntroPage.replace(/%%i/g,(_nPosttestAttempts+1));
			_sIntroPage = _sIntroPage.replace(/%%n/g,(parent._sPT_MaxAttempts > 0 ? parent._sPT_MaxAttempts : XsIntroPostTestNoLimit ));
		}else{
			
			// initialize non-tested out question total
			var nNonTestedOutTotal = _nObjectives;
			// set the question total to the number of questions not tested out of
			nNonTestedOutTotal = getNonTestedOutQuestionTotal();
			// subtract the number of objectives already tested out from the amount needed to pass
			var nRequiredToPass = _nRequiredCorrect - (_nObjectives - nNonTestedOutTotal);	
			
			// see if the user has tested out of more than the required amount
			if(nRequiredToPass < 0)
				// they have, so they need to test out of 0 objectives.
				nRequiredToPass = 0;
				
			// add the variable information to the required-to-pass string
			_sRequired = _sRequired.replace(/%%required/g,nRequiredToPass);
			_sRequired = _sRequired.replace(/%%total/g,nNonTestedOutTotal);
		
			// build the complete intro string
			// see if we have a custom introduction
			if (_sIntroCustom == "") {
				// we do not, just use the standard intro
				_sIntroPage = '<div class="levelOne">' + XsIntroTitle + sType + '</div>' + _sIntroPage;
			} else {
				_sIntroPage = '<div class="levelOne">' + XsIntroTitle + sType + '</div><p>' + _sIntroCustom + "</p> " + _sIntroPage;
			}
			_sIntroPage = _sIntroPage.replace(/%%required/g,nRequiredToPass);
			_sIntroPage = _sIntroPage.replace(/%%total/g,nNonTestedOutTotal);
		}
		
	// Get the Module number
		var nMod = parent._sPageCurrent.substring(0,parent._sPageCurrent.indexOf("_"));
		
		// See if this Knowledge Check has been tested out.
		if(parent._bPretest && parent._bTestOut && parent.isKCTestedOut(nMod)){
		
			// see if this KC is still in progress
			if(_sPassStatus == 'I'){
				
				if(parent._bPosttest)
					// Tell the user they will receive credit for the course
					alert(XsPostTestTestedOutMsg);
				else
					// Tell the user that they will recieve credit for this KC by clicking "OK"
					alert(XsKCTestedOutMsg);
				
				// Set the Pass Status manually
				//_sPassStatus = 'P';
				
				// Set the score manually
				//_nTotalScore = '100';
				
				// Process the KC
				//formatSuspendData();
			// see if user has already passed the KC
			}else if(_sPassStatus == 'P'){
				if(parent._bPosttest)
					// Tell he user they have already passed
					alert(XsPostTestTestedOutCompleteMsg);
				else
					// Tell the user they have already passed.
					alert(XsKCTestedOutCompleteMsg);
			}
		}
	}
	
	/* goto the initial page or the bookmarked page */
	gotoPage();
}

// set the onresize function to maximize the height of the TOC and content
window.onresize = resizeQuestion;

// called when the window is resized
function resizeQuestion() {
	// calc a height
	var nHeight = document.documentElement.clientHeight;
	
	// set the height of the question 
	var oQ = document.getElementById('question');
	if (oQ) oQ.style.height = (nHeight - 106) + "px";
}

function getObjectivesByTracks(aTracksSelected){
	var sArgs = "";
	// Loop through selected Tracks collection to gather required objective ids for the selected Tracks.
	for(var x = 0; x < _aTracksSelected.length;x++){
		var oTrack = parent._oTracks.Item(_aTracksSelected[x]);	
		if(x == (_aTracksSelected.length -1)){
			sArgs = sArgs + oTrack.objectives; 
		}else{
			sArgs = sArgs + oTrack.objectives + ',' ;
		}	
		
	}
	//gather the required objectives for all selected tracks from the collection, remove duplicates
	var aObjsByTracks = sArgs.split(',');
	
	aObjsByTracks = aObjsByTracks.removeDuplicate();//See Array util functions in CCollection.js
	return aObjsByTracks;
	
}

/* sObjId 			- is the Objective Id of the Objective that we are asking the question: is this required?
 * Loop thru the array of required objective ids and compare to the sObjId parameter for a match.
 * We we match set required to true and end the search, otherwise, keep searching
 */
function isObjRequired(sObjId){
	var bRequired;
	for (var i = 0; i < _aObjRequired.length;i++){	
		if(sObjId == String(_aObjRequired[i])){
			bRequired = true;
			break;
		}else{
			bRequired = false;
		}
	}
	return bRequired;
}


function totalQuestions(aTotalQuestions){
	var nTotal = 0;
	
	for(var i=0;i<aTotalQuestions.length;i++){
	 nTotal	= nTotal + aTotalQuestions[i]; 
	}
	
	return nTotal;
}


/***
* get the questions from the XMl document
***/
function getQuestions() {
	// get the XML document
	var oXML = getXmlDocument(assessXML);

	// get the id of this assessment
	var oTest = oXML.getElementsByTagName("test")[0];
	_nID = oTest.getAttribute("id") - 0;
	
	//if we are in a test-out, and it a pretest we need to answer all questions
	if (!inMain(parent)){
		//we are in a test-out, is it a pretest
		if(parent._bPretest){
			///yes, we must answer all questions for each objective to test out of the objective
			_bMustAnswerAll = true;
		}else{
			//no, we must correctly answer 1 question for each objective to test out the course.
			_bMustAnswerAll = false;
		}
	}else if(inMain(parent)){
		// see if we are in the post test
		if(parent._bPosttest){
			// we must actually score the test
			_bMustAnswerAll = false;
		}else{
			// set a global to see if the learner must answer all questions
			_bMustAnswerAll = (oTest.getAttribute("mustAnswerAll") == "true") ? true : false;
		}
	}
	
	
	// see if this is an adaptive test
	_bAdaptive = parent._bMultipleTracks && (oTest.getAttribute("allObjectivesRequired") == "false") ? true : false;
	
	// if this is a post test, it is automatically adaptive
	if(parent._bPosttest && (oTest.getAttribute("allObjectivesRequired") == null || oTest.getAttribute("allObjectivesRequired") == ""))
		_bAdaptive = true;
		
	// see if we have an adaptive test
	if (_bAdaptive) {
		// we do, get the list of selected tracks
		var sPrevSelected = parent.getState("TRACKS");
		
		// see if got a valid value (we will not when running without a LMS)
		if (sPrevSelected == "") {
			// we did not, get the value from the global
			sPrevSelected = parent._sTracksSelected;
		}
		
		// split the selected tracks into an array
		_aTracksSelected = sPrevSelected.split(",");

		//get an array of objectives based on the selected tracks
		_aObjRequired = getObjectivesByTracks(_aTracksSelected);
	}
	// get the array of objectives test XML 
	var oObjectives = oXML.getElementsByTagName("objective");
	// init the number of objectives
	_nObjectives = 0;

	//loop through all objectives defined in the test xml
	for (var i=0; i<oObjectives.length; i++) {
		//initialize the question count for the section
		_aTotalQuestions[i] = 0;
		
		// see if this objective is required based on adaptive testing
		// and the id of the objective.
		if (_bAdaptive && !isObjRequired(oObjectives[i].getAttribute("id")) ) {
			// it is not, continue to the next objective
			continue;
		}
		// create this section
		test[_nObjectives] = new Section();
		
		//store the objective id value for the session
		test[_nObjectives].id = oObjectives[i].getAttribute("id"); 
		
		//store the objective minscore / passing score value for the objective for an adaptive test out
		if (parent._bPretest) {
			test[_nObjectives].passingScore = parent._oObjectives.Item(test[_nObjectives].id).minscore;
		}
		
		
		//if we are in a Knowledge Check
		if (inMain(parent)){
			//we are in a Knowledge Check, see if there is a pretest
			if(parent._bPretest && parent._bTestOut){
				//yes, we must set the tested out state of this section if the associted objective has been tested out
				if(parent._oObjectives && parent._oObjectives.Item(test[_nObjectives].id).state == 1)
					// set this section to tested out. Questions in this section will not be shown in the KC
					test[_nObjectives].testedOut = "1";	
					
			}
		}
		
		// get the array of questions for this objective
		var oQuestions = oObjectives[i].getElementsByTagName("question");
		
		// loop through the questions
		for (var j=0; j<oQuestions.length; j++) {
			// create the question
			test[_nObjectives].pool[j] = new Question();
			
			// assign the prompt
			test[_nObjectives].pool[j].question = oQuestions[j].getElementsByTagName("prompt")[0].firstChild.data;
			
			// assign the type
			test[_nObjectives].pool[j].type = oQuestions[j].getAttribute("type");
			
			// see which type we have
			if (test[_nObjectives].pool[j].type == "true-false") {
				// true-false, get the array of choices
				var oChoices = oQuestions[j].getElementsByTagName("choice");
				
				// get the correct answer
				if (oChoices[0].getAttribute("correct") == "true") {
					test[_nObjectives].pool[j].answer = "t";
				} else {
					test[_nObjectives].pool[j].answer = "f";
				}
				
				// get the feedback
				test[_nObjectives].pool[j].feedbackCorrect = oQuestions[j].getElementsByTagName("feedbackCorrect")[0].firstChild.data;
				test[_nObjectives].pool[j].feedbackIncorrect = oQuestions[j].getElementsByTagName("feedbackIncorrect")[0].firstChild.data;
			} else if (test[_nObjectives].pool[j].type == "choice") {
				// multiple choice with single correct answer, get the array of choices
				var oChoices = oQuestions[j].getElementsByTagName("choice");
				
				// loop through the choices
				for (var k=0; k<oChoices.length; k++) {
					// see if this is the correct answer
					if (oChoices[k].getAttribute("correct") == "true") {
						// it is, remember it
						test[_nObjectives].pool[j].answer = (k+1) + "";
					}
					
					// add this choice
					test[_nObjectives].pool[j].choice[k] = oChoices[k].firstChild.data;
				}
				
				// get the feedback
				var oFeedback = oQuestions[j].getElementsByTagName("feedback");
				
				// loop through the feedback
				for (k=0; k<oFeedback.length; k++) {
					// add this feedback
					test[_nObjectives].pool[j].feedback[k] = oFeedback[k].firstChild.data;
				}
						
			} else if (test[_nObjectives].pool[j].type == "choice-multiple") {
				// multiple choice with single correct answer, get the array of choices
				var oChoices = oQuestions[j].getElementsByTagName("choice");
				
				// init the answer to a blank string
				test[_nObjectives].pool[j].answer = "";
				
				// loop through the choices
				for (var k=0; k<oChoices.length; k++) {
					// see if this is a correct answer
					if (oChoices[k].getAttribute("correct") == "true") {
						// it is, see if this is the first correct answer
						if (test[_nObjectives].pool[j].answer == "") {
							// it is, just add the answer
							test[_nObjectives].pool[j].answer += (k+1) + "";
						} else {
							// add a comma plus the answer
							test[_nObjectives].pool[j].answer += "," + (k+1);
						}
					}
					
					// add this choice
					test[_nObjectives].pool[j].choice[k] = oChoices[k].firstChild.data;
				}
				
				// get the feedback
				test[_nObjectives].pool[j].feedbackCorrect = oQuestions[j].getElementsByTagName("feedbackCorrect")[0].firstChild.data;
				test[_nObjectives].pool[j].feedbackIncorrect = oQuestions[j].getElementsByTagName("feedbackIncorrect")[0].firstChild.data;
			}
			// get the ID
			test[_nObjectives].pool[j].id = oQuestions[j].getAttribute("id");
			
			// get the review text and link
			test[_nObjectives].pool[j].reviewText = oQuestions[j].getElementsByTagName("reviewText")[0].firstChild.data;
			test[_nObjectives].pool[j].reviewLink = oQuestions[j].getElementsByTagName("reviewLink")[0].firstChild.data;
		}
		
		//store the # of questions in array
		_aTotalQuestions[_nObjectives] = test[_nObjectives].pool.length;
		// increment the count of objectives
		_nObjectives++;
		}
	
	//convert array of question counts to a total;
	_nQuestions = totalQuestions(_aTotalQuestions);
	
	//are we running from the KCInit.htm file
	if(inResults(window)){
		//yes we are
		// see if this is a test-out
		if (!inMain(parent)) {
			if(parent._bPosttest){
				// it is, calculate the passing as 80% of the total number of questions, round up if needed
				_nRequiredCorrect = Math.ceil(_nQuestions * (parent._sPT_MinScore / 100));
			}else{
				// see if this is an adaptive test
				if (_bAdaptive) {
				// it is, calculate the passing as 80% of the total number of questions, round up if needed
					_nRequiredCorrect = Math.ceil(_nObjectives * (parent._sMinTestOutScore / 100));
				} else {	
					// not an adaptive test, get the passing score
					_nRequiredCorrect = oTest.getAttribute("passing") - 0;
				}
			}
		// see if we are in the post test
		}else if(parent._bPosttest){
			// it is, calculate the passing as 80% of the total number of questions, round up if needed
			_nRequiredCorrect = Math.ceil(_nQuestions * (parent._sPT_MinScore / 100));
		}
	}else{
		
		// no we aren't, 
		// see if this is a test-out
		if (!inMain(parent)) {
			//it is, see if this is a pretest
			if(parent._bPretest){
				// it is, see if this is an adaptive test
				if (_bAdaptive) {
					// it is, calculate the passing as 80% of the total number of questions, round up if needed
					_nRequiredCorrect = Math.ceil(_nQuestions * (parent._sMinTestOutScore / 100));
				} else {	
					// not an adaptive test, get the passing score from the xml
					_nRequiredCorrect = oTest.getAttribute("passing") - 0;
				}
	
				// it is, use the pre-test intro page
				_sIntroPage = XsIntroPreTest;
			}else{
				// see if this is an adaptive test
				if (_bAdaptive) {
				// it is, calculate the passing as 80% of the total number of objectives, round up if needed
					_nRequiredCorrect = Math.ceil(_nObjectives * (parent._sMinTestOutScore / 100));
				} else {	
				// not an adaptive test, get the passing score
					_nRequiredCorrect = oTest.getAttribute("passing") - 0;
				}			
				// it isn't, use the test-out intro page
				_sIntroPage = XsIntroTestOut;
			}
		//this is KC or Post Test
		} else {
			// see if we are in the post test
			if(parent._bPosttest){
				// it is, calculate the passing as 80% of the total number of questions, round up if needed
				_nRequiredCorrect = Math.ceil(_nQuestions * (parent._sPT_MinScore / 100));
			
				// build the complete intro string
				_sIntroPage = '<div class="levelOne">' + XsIntroTitle + '</div>' + _sIntroPage;
			}else{
				// see if this is an adaptive test
				if (_bAdaptive) {
				// it is, calculate the passing as 80% of the total number of questions, round up if needed
					_nRequiredCorrect = Math.ceil(_nObjectives * (parent._sMinTestOutScore / 100));
				} else {	
					// not an adaptive test, get the passing score
					_nRequiredCorrect = oTest.getAttribute("passing") - 0;
				}
				
				// a knowledge check, see if the user must answer all questions
				if (_bMustAnswerAll) {
					// he must, get the right into
					_sIntroPage = XsIntroMust;
				} else {
					// dow nto have to answer all
					_sIntroPage = XsIntro;
				}
				
				// see if we need to show optional/required modules
				if (parent._bShowOptional) {
					// we do, get the module number
					var nMod = parent._sPageCurrent.substring(0,parent._sPageCurrent.indexOf("_")) - 1;
					
					// see which word to show
					if (parent._aModRequired[nMod]) {
						// required
						var sType = '';
					} else {
						// optional
						var sType = '<span class="pageOptional" title="' + parent._sOptionalExplanation + '"> (' + parent._sOptional + ')</span>';
					}
				} else {
					// none
					var sType = '';
				}
				
				// build the complete intro string
				_sIntroPage = '<div class="levelOne">' + XsIntroTitle + sType + '</div>' + _sIntroPage;	
			}
		}
		
	
		// see if we are in test out mode
		if (!inMain(parent)){
			if(parent._bPretest){
	
				_sIntroPage = _sIntroPage.replace(/%%required/g,_nRequiredCorrect);
				_sIntroPage = _sIntroPage.replace(/%%total/g,_nQuestions);
				
				// get the passing results
				_sResultsPassing = oXML.getElementsByTagName("results-passed");
				if (_sResultsPassing.length) _sResultsPassing = _sResultsPassing[0].firstChild.data;
				
				// get the failing results
				_sResultsFailing = oXML.getElementsByTagName("results-failed");
				if (_sResultsFailing.length) _sResultsFailing = _sResultsFailing[0].firstChild.data;
				
				// get the incomplete results
				_sResultsIncomplete = oXML.getElementsByTagName("results-incomplete");
				if (_sResultsIncomplete.length) _sResultsIncomplete = _sResultsIncomplete[0].firstChild.data;		
			
			}else{
				_sIntroPage = _sIntroPage.replace(/%%required/g,_nRequiredCorrect);
				_sIntroPage = _sIntroPage.replace(/%%total/g,_nObjectives);
				
				// get the passing results
				_sResultsPassing = oXML.getElementsByTagName("results-passed");
				if (_sResultsPassing.length) _sResultsPassing = _sResultsPassing[0].firstChild.data;
				
				// get the failing results
				_sResultsFailing = oXML.getElementsByTagName("results-failed");
				if (_sResultsFailing.length) _sResultsFailing = _sResultsFailing[0].firstChild.data;
				
				// get the incomplete results
				_sResultsIncomplete = oXML.getElementsByTagName("results-incomplete");
				if (_sResultsIncomplete.length) _sResultsIncomplete = _sResultsIncomplete[0].firstChild.data;
			}
		}else{
			if(parent._bPosttest){
				_sIntroPage = _sIntroPage.replace(/%%required/g,_nRequiredCorrect);
				_sIntroPage = _sIntroPage.replace(/%%total/g,_nObjectives);
				
				// See if the course has already been completed
				if(parent.isComplete()){
					_sResultsPassing = XsSummaryPostTestCompleted;
					_sResultsFailing = XsSummaryPostTestCompleted;
				// see if user has exhausted their attempts
				}else if(parent._sPT_MaxAttempts > 0 && _nPosttestAttempts >= parent._sPT_MaxAttempts){
					_sResultsPassing = XsSummaryPostTestPassed;
					_sResultsFailing = XsSummaryPostTestNoAttempts;
				}else{
					_sResultsPassing = XsSummaryPostTestPassed;
					_sResultsFailing = XsSummaryPostTestIncomplete;
					_sResultsIncomplete = XsSummaryPostTestIncomplete;
				}	
			}else{
				_sIntroPage = _sIntroPage.replace(/%%required/g,_nRequiredCorrect);
				_sIntroPage = _sIntroPage.replace(/%%total/g,_nObjectives);
				
				// get the knowledge check-specific introduction
				_sIntroCustom = oXML.getElementsByTagName("introduction");
				if (_sIntroCustom.length) _sIntroCustom = _sIntroCustom[0].firstChild.data;
				
				// get the passing results
				_sResultsPassing = oXML.getElementsByTagName("results-passed");
				if (_sResultsPassing.length) _sResultsPassing = _sResultsPassing[0].firstChild.data;
				
				// get the failing results
				_sResultsFailing = oXML.getElementsByTagName("results-failed");
				if (_sResultsFailing.length) _sResultsFailing = _sResultsFailing[0].firstChild.data;
				
				// get the incomplete results
				_sResultsIncomplete = oXML.getElementsByTagName("results-incomplete");
				if (_sResultsIncomplete.length) _sResultsIncomplete = _sResultsIncomplete[0].firstChild.data;
			}
		}
	}//inResults
}

// return true if the objective is required based on track selections
//	sTrackList - a comma separated list of tracks for this objective, example 1,2
function isObjectiveRequired(sTrackList) {
	// see if there is a track list
	if (sTrackList == null) {
		// the track list is undefined, return true
		return true;
	}
	
	// break the list of tracks into an array
	var aTrackList = sTrackList.split(",");
	
	// loop through the list of tracks for this objective
	for (var i=0; i<aTrackList.length; i++) {
		// loop through the array of selected tracks
		for (var j=0; j<_aTracksSelected.length; j++) {
			// see if this is a match
			if (_aTracksSelected[j] == aTrackList[i]) {
				// it is, stop looking
				return true;
			}
		}
	}
	
	// no match, return false
	return false;
}

/***
* check to see if there is a timeout and update the time display
***/
function timeCheck() {
	/* caculate the elapsed time from the start of this test */
	var dateNow = new Date();
	var nTime = dateNow.getTime() - _timeStart;	
	
	/* see if we have run out of time */
	if (nTime > _timeLimitMS) {
		/* we have, cancel the timer */
		clearInterval(_timerTest);
		
		/* remember that we have reached the time limit */
		_bTimeLimitReached = true;		
		
		/* show the timeout alert */
		showTimeoutAlert();
	} else {
		/* calculate the remaining time in seconds */
		nTime = Math.round((_timeLimitMS - nTime) / 1000);
		
		/* see if the remaining time is greater than a minute */
		if (nTime > 60) {
			/* it is, get the number of minutes */
			var nMinutes  = Math.floor(nTime / 60);
			
			/* get the remaining seconds */
			nTime  = Math.floor(nTime -(nMinutes * 60));
			
			/* see if the number of seconds is less than 10 */
			if (nTime < 10) {
				/* it is, pad with a zero */
				nTime = "0" + nTime;
			}
			
			/* format the time */
			nTime = nMinutes + ":" + nTime;
		}
		
		/* update the time display */
		document.getElementById("timeLimit").innerHTML = XsMsgTime + nTime;
	}
}

/***
* save the session data
***/
function saveCurrentState() {
	// see if we are in post test review mode
	if(parent._bPosttest && _bPosttestReviewMode)
		// we are, don't save anything.
		return;
	// format the state data
	var sState = formatSuspendData();
	// see if this state is the same as before
	if (_sReportedState != sState) {
		// it is not, remember the new state
		_sReportedState = sState;
	
		// send the state to the parent
		if (parent.saveKcState) {
			parent.saveKcState(_nID-1, sState);
		}
	}
}

/***
* set the score and completion status

function setScoreAndCompletion() {
	// get the score //
	var nScore = calcScore()/ 100;

	// set the score //
	setScore(nScore);
	
	// set the completion status //
	setCompletionStatus(getPassed(nScore));
	
	// set the exit status //
	learnerWillReturn(false);
}
*/
/**********************
* Functions for both stand-alone and embedded
***********************/
/*********
*
* break apart the SCORM data from the suspend_session and inits control variables
*	sData - contents of session_data
* 	Breaks apart _aOrder array + _sSep1 + tripplets of (test[i].selected + _sSep2 + learner-response-to-question + _sSep2 + attempts)
**********/
function reloadState(sData) {
	var aParts;
	/* break the data apart */
	var aAll = sData.split(_sSep1);
	
	// check to see if we have the right amount of data
	if (aAll.length < (_nObjectives+2)) {
		// we have a problem, we cannot restore the state so intialize it
		setOrder();
		return;
	}
	
	// the first item is the pass status
	_sPassStatus = aAll[0];	
	
	// the second item is the score
	_nTotalScore = aAll[1] - 0;
	
	// the third item is the  - recreate it
	_aOrder = aAll[2].split("-");

	// the fourth order is the curent section + _sSep2 + _bSubmitWarning
	aParts = aAll[3].split(_sSep2);
	_nSectionCurrent = aParts[0] - 0;
	_bSubmitWarning = aParts[1] == "1" ? true : false;
	
	if(_nSectionCurrent > -1)
		_bTestStarted = true;
	// loop through the sections in the test
	for (var i=0; i<_nObjectives; i++) {
		// selected question from the pool + _sSep2 + the response to the question + _sSep2 + attempts
		// break the pair apart
		aParts = aAll[i+4].split(_sSep2);
		
		// get the selected question
		var nSelected = aParts[0];
		
		// see if this section has a selected question
		if (nSelected > -1) {
			// we do, restore the response to the selected question
			test[i].selected = nSelected;
			test[i].pool[ nSelected ].response = aParts[1];
			test[i].pool[ nSelected ].attempts = aParts[2]-0;
		}
	}
	// set the tested out order
	_aTestedOutOrder = new Array();
	for (var i=0; i<_nObjectives; i++) {
		// See if this section has been tested out
		if(test[_aOrder[i]].testedOut == '1')
			// it has, set the order counter here to -1 to indicate no section
			_aTestedOutOrder[i] = -1;
		else
			// not tested out, so set it to whatever section is in the order.
			_aTestedOutOrder[i] = _aOrder[i];
	}
}

function reloadPosttestState(sData) {
	var aParts;
	//aParts[0] - Pass Status
	//aParts[1] - Total Score
	//aParts[2] - Section Order
	//aParts[3] - Current Section ^^ Submit Warning ^^ Current Question
	//aParts[4] - Question 1 Data
	//aParts[n] - Question n Data
	
	/* break the data apart */
	var aAll = sData.split(_sSep1);
	
	// check to see if we have the right amount of data
	if (aAll.length < (_nQuestions+2)) {
		// we have a problem, we cannot restore the state so intialize it
		setOrder();
		return;
	}
	
	// the first item is the pass status
	_sPassStatus = aAll[0];	
	
	// the second item is the score
	_nTotalScore = aAll[1] - 0;
	
	// the third item is the section order- recreate it
	_aOrder = aAll[2].split("-");
	
	// the fourth order is the _nSectionCurrent + _sSep2 + _bSubmitWarning + _sSep2 + _nQuestionCurrent
	aParts = aAll[3].split(_sSep2);
	
	_nSectionCurrent = Number(aParts[0]);
	
	_bSubmitWarning = aParts[1] == "1" ? true : false;
	
	_nQuestionCurrent = Number(aParts[2]);
	
	_nQuestionCount = Number(aParts[3]);
	
	//init question count
	var nQCount = 0; 
	
	// loop through the sections in the test
	for(var i=0; i<_nObjectives;i++){
		//loop through the questions in the section
		for (var j=0; j<test[i].pool.length; j++) {
		
			// get selected question from the pool + _sSep2 + the response to the question + _sSep2 + attempts
			
			// break the pair apart
			aParts = aAll[nQCount+4].split(_sSep2);
			
			// get the question from the pool
			var nQuestion = test[i].pool[j];
			
			// see if this section has a selected question
			if (nQuestion != null) {
				// we do, restore the response to the selected question
				test[i].selected = j;
				
				if(aParts[1] != "")
					nQuestion.response = aParts[1];
				
				if(aParts[2] != "")
					nQuestion.attempts = aParts[2]-0;
			}
			nQCount++;
		}
		
	}	
	
	// set the tested out order
	_aTestedOutOrder = new Array();
	for (var i=0; i<_nObjectives; i++) {
		// See if this section has been tested out
		if(test[_aOrder[i]].testedOut == '1')
			// it has, set the order counter here to -1 to indicate no section
			_aTestedOutOrder[i] = -1;
		else
			// not tested out, so set it to whatever section is in the order.
			_aTestedOutOrder[i] = _aOrder[i];
	}
}

//var _sSep1 = "::";  //Seperate Discrete Data on CYK 
//var _sSep2 = "^^";	//Seperate Question Data on CYK 
function reloadPretestState(sData){
	
	var aParts;
	//aParts[0] - Pass Status
	//aParts[1] - Total Score
	//aParts[2] - Section Order
	//aParts[3] - Current Section ^^ Submit Warning ^^ Current Question
	//aParts[4] - Question 1 Data
	//aParts[n] - Question n Data
	
	/* break the data apart */
	var aAll = sData.split(_sSep1);
	
	// check to see if we have the right amount of data
	if (aAll.length < (_nQuestions+2)) {
		// we have a problem, we cannot restore the state so intialize it
		setOrder();
		return;
	}
	
	// the first item is the pass status
	_sPassStatus = aAll[0];	
	
	// the second item is the score
	_nTotalScore = aAll[1] - 0;
	
	// the third item is the section order- recreate it
	_aOrder = aAll[2].split("-");

	// the fourth order is the _nSectionCurrent + _sSep2 + _bSubmitWarning + _sSep2 + _nQuestionCurrent
	aParts = aAll[3].split(_sSep2);
	
	_nSectionCurrent = Number(aParts[0]);
	
	_bSubmitWarning = aParts[1] == "1" ? true : false;
	
	_nQuestionCurrent = Number(aParts[2]);
	
	_nQuestionCount = Number(aParts[3]);
	
	//init question count
	var nQCount = 0; 
	
	// loop through the sections in the test
	for(var i=0; i<_nObjectives;i++){
		//loop through the questions in the section
		for (var j=0; j<test[i].pool.length; j++) {
		
			// get selected question from the pool + _sSep2 + the response to the question + _sSep2 + attempts
			
			// break the pair apart
			aParts = aAll[nQCount+4].split(_sSep2);
			
			// get the question from the pool
			var nQuestion = test[i].pool[j];
			
			// see if this section has a selected question
			if (nQuestion != null) {
				// we do, restore the response to the selected question
				test[i].selected = j;
				
				if(aParts[1] != "")
					nQuestion.response = aParts[1];
				
				if(aParts[2] != "")
					nQuestion.attempts = aParts[2]-0;
			}
			nQCount++;
		}
		
	}	
	
}

/*
 * 		//loop through the pool for each section
		for(var j=0; j < test[i].pool.length; j++){
			_aQuestOrder[i] = new Array(2);
			//add the Question Object to the array
			_aQuestOrder[i][j] = test[i].pool[j];
				
		}
		* 
		* //loop thru all sections up to the currently selected session
		for(var i=0; i <= _nSectionCurrent; i++){
			//if we it our current session we want the value of the current question in the pool
			if(i == _nSectionCurrent){
				//add the number of questions to the temp variable
				nQNum += Number(_nQuestionCurrent + 1);
				continue;
			}
			//for all other sections that come before our current section, add the number for all questions in the pool.	
			nQNum += test[i].pool.length;
				
		}
		//the total number of questions from all preceeding sections, plus the # of questions up to the currently selected is the question count.
		_nQuestionCount = nQNum;
 */

/***
* assemble and return the suspend data
* Saves the _aOrder array + _sSep1 + tripplets of (test[i].selected + _sSep2 + learner-response-to-question + attempts)
***/
function formatSuspendData() {
	// save the pass status
	var sData = _sPassStatus + _sSep1;
	
	// save the score
	sData += _nTotalScore + _sSep1;
	
	//are we in a testout AND in pretest mode
	if(!inMain(parent) && parent._bPretest){
		//yes we are, track as a pre-test

		// save the order array  (sections)
		sData += _aOrder.join("-") +  _sSep1;
		
		// save the current section + _sSep2 + _bSubmitWarning + _sSep2 + current question
		var sSubmitWarning = _bSubmitWarning ? "1" : "0";

		sData += _nSectionCurrent  + _sSep2 + sSubmitWarning + _sSep2 + _nQuestionCurrent + _sSep2 + _nQuestionCount + _sSep1;
		
		// use this var to see if we need to tack on a separator
		var bFirst = true;
	
		/* loop through the sections of the test */
		for (var i=0; i<_nObjectives; i++) {
			
			// get the selected question for this section
			var nSelected = test[i].selected;
			
			/* loop through the questions in the section */
			for( var j=0; j < test[i].pool.length;j++){
				//get the question object for the section / pool
				var nQuestion = test[i].pool[j];
				
				// see if there is a response to this question
				if (nQuestion.response == "") {
					// there is not, set the question + _sSep2 + "" (no response)
					var sResponse = "" + j + _sSep2 + "";
				} else {
					// get the selected question + _sSep2 + learner-response + _sSep2 + attempts
				 	var sResponse = "" + j + _sSep2 + nQuestion.response + _sSep2 + nQuestion.attempts + "";
				}
				
				// see if this is the first item to add
				if (bFirst) {
					/* it is, just add the data */
					sData += sResponse;
					bFirst = false;
				} else {
					/* add on the separator and the data */
					sData += _sSep1 + sResponse;
				}
			}
		}
	//no, we aren't, track as a test-out or KC	
	}else{
		if(parent._bPosttest){
			// save the order array
			sData += _aOrder.join("-") + _sSep1;
			
			// save the current section + _sSep2 + _bSubmitWarning
			var sSubmitWarning = _bSubmitWarning ? "1" : "0";
			sData += _nSectionCurrent  + _sSep2 + sSubmitWarning + _sSep1;
			
			// use this var to see if we need to tack on a separator
			var bFirst = true;
		
			/* loop through the sections of the test */
			for (var i=0; i<_nObjectives; i++) {
				for(var j=0; j < test[_aOrder[i]].pool.length; j++){
					// get the selected question + _sSep2 + learner-response + _sSep2 + attempts
					 var sResponse = nSelected + _sSep2 + test[_aOrder[i]].pool[j].response + _sSep2 + test[_aOrder[i]].pool[j].attempts;
					
					// see if this is the first item to add
					if (bFirst) {
						/* it is, just add the data */
						sData += sResponse;
						bFirst = false;
					} else {
						/* add on the separator and the data */
						sData += _sSep1 + sResponse;
					}
				}
					
			}
	
			parent.setState("PST",""+_nPosttestAttempts);
		}else{
			// save the order array
			sData += _aOrder.join("-") + _sSep1;
			
			// save the current section + _sSep2 + _bSubmitWarning
			var sSubmitWarning = _bSubmitWarning ? "1" : "0";
			sData += _nSectionCurrent  + _sSep2 + sSubmitWarning + _sSep1;
			
			// use this var to see if we need to tack on a separator
			var bFirst = true;
		
			/* loop through the sections of the test */
			for (var i=0; i<_nObjectives; i++) {
				// get the selected question for this section
				var nSelected = test[i].selected;
				
				// see if there is a question selected for this section
				if (nSelected == -1) {
					// there is not, get the selected question + _sSep2 + "" (no response)
					var sResponse = nSelected + _sSep2 + "";
				} else {
					// get the selected question + _sSep2 + learner-response + _sSep2 + attempts
				 	var sResponse = nSelected + _sSep2 + test[i].pool[ nSelected ].response + _sSep2 + test[i].pool[ nSelected ].attempts;
				}
				
				// see if this is the first item to add
				if (bFirst) {
					/* it is, just add the data */
					sData += sResponse;
					bFirst = false;
				} else {
					/* add on the separator and the data */
					sData += _sSep1 + sResponse;
				}
			}
		}
	}
	
	return sData;
}

/*********
*
* set the order for this test, this function is called for the first launch of the test
*
**********/
function setOrder() {
	var i;
	//are we in a test out in pretest mode
	if(!inMain(parent) && parent._bPretest){
		//yes we are, create the order array
		
		//this array defines the order to deliver the objectives of the test
		//the size of the array will be the same as the number of objectives
		_aOrder = new Array();
		for (i=0; i<_nObjectives; i++) {
			_aOrder[i] = i;
		}
		
		/* see if we need to deliver the sections in random order */
		if (randomizeTest) {
			// we do, randomize it
			_aOrder.shuffle();
		}
		
		var nQNum = 0;
		// loop through the sections
		for(i=0; i<_nObjectives; i++) {
			// see if we want to randomize the pool
			if (randomizePool) {
				// we do, shuffle the pool 
				test[i].pool.shuffle();
			}
			
			// select the first item in the pool
			test[i].selected = 0;
		}

		// see if we want to show the introduction page
		if (_bShowIntro) {
			// we do, set the section index to -1
			_nSectionCurrent = -1;
			_nQuestionCurrent = -1;
		}		
		
	}else{
		// create the order array, this array defines the order to deliver the objectives of the test
		// the size of the array will be the same as the number of objectives
		_aOrder = new Array();
		_aTestedOutOrder = new Array();
		for (i=0; i<_nObjectives; i++) {
			_aOrder[i] = i;
		}
		
		/* see if we need to deliver the sections in random order */
		if (randomizeTest) {
			// we do, randomize it
			_aOrder.shuffle();
		}
		
		// loop through the sections
		for(i=0; i<_nObjectives; i++) {
			// see if we want to randomize the pool
			if (randomizePool) {
				// we do, shuffle the pool 
				test[i].pool.shuffle();
			}
		// See if this section has been tested out
		if(test[_aOrder[i]].testedOut == '1')
			// it has, set the order counter here to -1 to indicate no section
			_aTestedOutOrder[i] = -1;
		else
			// not tested out, so set it to whatever section is in the order.
			_aTestedOutOrder[i] = _aOrder[i];
			
			// select the first item in the pool
			test[i].selected = 0;
		}
		
		// see if we want to show the introduction page
		if (_bShowIntro) {
			// we do, set the section index to -1
			_nSectionCurrent = -1;
			_nQuestionCurrent = -1;
		}		
		
	}
}

/***
* get the number of questions that have an answer
***/
function getComplete() {
	var nTotal = 0;

	if(!inMain(parent) && parent._bPretest){
		// loop through the sections 
		for (var i=0; i<_nObjectives; i++) {
			// loop though the questions 
			for( var j=0; j<test[i].pool.length;j++){
				// get the section questions
				var nQSelect = test[i].pool[j];
			
				// see if there are questions in the pool
				if (nQSelect.length > -1) {
					// see if the question has a response 
					if (test[i].pool[j].response != "") {
						// it does, increment the count 
						nTotal ++;
					}
				}
			}
		}
	
	}else{
		/* loop through the questions */
		for (var i=0; i<_nObjectives; i++) {
			// get the selected question for this section
			var nSelect = test[i].selected;
	
			// see if there was a question selected
			if (nSelect > -1) {
				/* see if the question has a response */
				if (test[i].pool[nSelect].response != "") {
					/* it does, increment the count */
					nTotal ++;
				}
			}
		}
	}
	/* return the number of questions complete */
	return nTotal;
}

function calcTestedObjectives(){
	//get the array of tested out objectives
	var aObjsByTracks = _aObjState.removeDuplicate();
	//save the tested out objectives to suspend data
	parent.setState("OBJ",aObjsByTracks);
	
}

function calcPretest(){
	/* calculate the value of each question */
	var nEach = 100/_nQuestions;
	_nTotalScore = 0;
	
	// init the number of questions answered correctly, incorrectly and answered
	_nCorrect = 0;
	_nIncorrect = 0;
	_nAnswered = 0;
		
	/* loop through the sections and score the questions */
	for (var i=0; i<_nObjectives; i++) {
		//init user score
		var nObjScore = 0;
		try{
			/*loop through the questions and score the objectives*/
			for(var j=0; j<test[i].pool.length;j++){
				// get the selected question for this section
				var nSelect = test[i].selected;
				var nQuestion = test[i].pool[j];
			
				// see if there was a question selected
				if (nSelect > -1) {
					// there was, see if we have the correct answer for the selected question
					if (test[i].pool[j].response == test[i].pool[j].answer) {
						// it is correct, increment EXCEPT when we have a submit warning AND this is the current Q
						//if (!(_bSubmitWarning)){//  && _nSectionCurrent == _aOrder[i] && _nQuestionCurrent == j) {
						if (!(_bSubmitWarning && _nSectionCurrent == _aOrder[i] && _nQuestionCurrent == j)){
							// it is, increment the score
							_nTotalScore += nEach;
							_nCorrect++;
							_nAnswered++;
							//add a point to this sections score.
							nObjScore++;
						}
					} else {
						// see if this is an incorrect response
						if (test[i].pool[nSelect].response != "") {
							// incorrect, increment EXCEPT when we have a submit warning AND this is the current Q
							if (!(_bSubmitWarning && _nSectionCurrent == i)) {
								_nIncorrect++;
								_nAnswered++;
							}
						}
					}
				}
			}
			//set the users score for the section based on the objective score
			test[i].userScore = nObjScore;
		}catch(e){
			alert(e.message);
		}
	}
	
	//log passed objectives
	for (var k=0; k < _nObjectives; k++) {
		//if the user score equal / greater than the passing score
		if(test[k].userScore >= test[k].passingScore){
			//yes, log the id of the objective in the array
			_aObjState[_aObjState.length] = test[k].id;
		}
	}
	//calculate the objectives currently testout out of
	calcTestedObjectives();
	// return the score as an integer
	_nTotalScore = Math.round(_nTotalScore);
	return _nTotalScore;
}

// This function calculates the current score of hte post test
function calcPosttest(){
	/* calculate the value of each question */
	var nEach = 100/_nQuestions;
	
	_nTotalScore = 0;
	
	// init the number of questions answered correctly, incorrectly and answered
	_nCorrect = 0;
	_nIncorrect = 0;
	_nAnswered = 0;
	
	/* loop through the questions and score the test */
	for (var i=0; i<_nObjectives; i++) {
		for(var j=0; j<test[_aOrder[i]].pool.length;j++){
			// there was, see if we have the correct answer for the selected question
			if (test[_aOrder[i]].pool[j].response == test[_aOrder[i]].pool[j].answer) {
				// it is correct, increment EXCEPT when we have a submit warning AND this is the current Q
				if (!(_bSubmitWarning && _nSectionCurrent == _aOrder[i] && _nQuestionCurrent == j)) {
					// it is, increment the score
					_nTotalScore += nEach;
					_nCorrect++;
					_nAnswered++;
				}
			} else {
				// see if this is an incorrect response
				if (test[_aOrder[i]].pool[j].response != "") {
					// incorrect, increment EXCEPT when we have a submit warning AND this is the current Q
					if (!(_bSubmitWarning && _nSectionCurrent == _aOrder[i])) {
						_nIncorrect++;
						_nAnswered++;
					}
				}
			}
		}
	}
	// make sure we can't have a higher score that 100%
	if(_nTotalScore > 100)
		_nTotalScore = 100;
		
	// return the score as an integer
	_nTotalScore = Math.round(_nTotalScore);
	return _nTotalScore;
}

/***
* returns the raw score and updates the number of correct answers
***/
function calcScore() {
	/* calculate the value of each section */
	var nEach = 100/_nObjectives;
	_nTotalScore = 0;
	
	// init the number of questions answered correctly, incorrectly and answered
	_nCorrect = 0;
	_nIncorrect = 0;
	_nAnswered = 0;
	
	/* loop through the questions and score the test */
	for (var i=0; i<_nObjectives; i++) {
		// get the selected question for this section
		var nSelect = test[i].selected;
		
		// see if there was a question selected
		if (nSelect > -1) {
			// there was, see if we have the correct answer for the selected question
			if (test[i].pool[nSelect].response == test[i].pool[nSelect].answer) {
				// it is correct, increment EXCEPT when we have a submit warning AND this is the current Q
				if (!(_bSubmitWarning && _nSectionCurrent == i)) {
					// it is, increment the score
					_nTotalScore += nEach;
					_nCorrect++;
					_nAnswered++;
				}
			} else {
				// see if this is an incorrect response
				if (test[i].pool[nSelect].response != "") {
					// incorrect, increment EXCEPT when we have a submit warning AND this is the current Q
					if (!(_bSubmitWarning && _nSectionCurrent == i)) {
						_nIncorrect++;
						_nAnswered++;
					}
				}
			}
		}
	}

	// return the score as an integer
	_nTotalScore = Math.round(_nTotalScore);
	return _nTotalScore;
}

/***
* returns passed or failed
*	nScore - the course score
***/
function getPassed(nScore) {
	/* see if score is greater than the passing score */
	if (nScore >= _nPassingScore)
		return "passed";

	return "failed";
}

/***
* Randomly selects a question from the pool, returns the question object
***/
function selectQuestionFromPool() {
	// the _aOrder array tells us the actual section to select, so get the section from that array
	// we use the _aOrder array to randomize the sections
	var nSelect = _aOrder[_nSectionCurrent];
	
	if (!inMain(parent)){
		//is this a pretest
		if(parent._bPretest){
			//is the number of asked questions >= the # in the pool
			var nQSelect = test[nSelect].pool[_nQuestionCurrent];
			return nQSelect;
		}else{
			// return the previously selected question from this section
			return test[nSelect].pool[ test[nSelect].selected ];	
		}
	}else{
		
		// see if we are in the post test
		if(parent._bPosttest){
			// return the previously selected question from this section
			return  test[nSelect].pool[_nQuestionCurrent];		
		}else{
			// See if there was a Pretest
			if(parent._bPretest && parent._bTestOut){
				// There was, loop through the sections until we find one that has not been tested out of
				if(test[nSelect].testedOut == '1'){
					setNextSection();
					// we have not run out of sections, select the next one
					nSelect = _aOrder[_nSectionCurrent];
				}
			}
			// return the previously selected question from this section
			return test[nSelect].pool[ test[nSelect].selected ];		
		}
	}

}

/***
* Called when the Next button is clicked.
***/
function NextPage() {
	
	// User has begun the test
	_bTestStarted = true;
	// see if we are in the post test and this is a new attempt
	if(parent._bPosttest && !_bPosttestAttempted){
		// we are, so set this Post test to attempted
		_bPosttestAttempted = true;
		// increment the number of attempts
		_nPosttestAttempts++;
	}
	
	//_bSubmitWarning - see if we have already warned the user about submitting
	if (_bSubmitWarning) {
		// we have warned, remove the response
		_oQuestion.response = "";
		
		// turn off the warning
		_bSubmitWarning = false;
		
		if (!inMain(parent)){
			// is this a pretest
			if(parent._bPretest == true){
				//it is, is the section initialized
				if(_nSectionCurrent == -1){ 
					//it isn't increment the section count
					_nSectionCurrent++;	
					//_nQuestionCurrent++;
				}
				
				//have all the questions in the section been asked
				if(_nQuestionCurrent == Number(test[_nSectionCurrent].pool.length-1)){
					
					//yes, move to the next section
					_nSectionCurrent++;
					
					//reset the current question
					_nQuestionCurrent = 0;
					_nQuestionCount++;
					// go to the next page (next section, first question)
					gotoPage();
		
					return false;
				}else{
				// increment the question count
					_nQuestionCurrent++;
					_nQuestionCount++;
				}
			
			//it isn't a pretest, it's a testout
			}else{
				//increment the question count
				_nSectionCurrent++;
			}
		//it's a KC
		}else{
			if(parent._bPosttest){
				if(_nSectionCurrent == -1){
					// Hide Welcome Button
					if(parent.document.getElementById("Welcome"))
						parent.document.getElementById("Welcome").style.display = "none";
					 // increment the section.
					setNextSection();
				}
				//have all the questions in the section been asked
				if(_nQuestionCurrent == Number(test[_nSectionCurrent].pool.length-1)){
					
					//yes, move to the next section
					setNextSection();
			
					//reset the current question
					_nQuestionCurrent = 0;
					_nQuestionCount++;
					
					// go to the next page (next section, first question)
					gotoPage();
		
					return false;
				}else{
				// increment the question count
					_nQuestionCurrent++;
					_nQuestionCount++;
				}
			}else{
				// increment the section.
				setNextSection();
			}
		}
		
		// go to the next page
		gotoPage();
	
		return false;
	}//_bSubmitWarning
	
	
	//Next - Are we in pretest mode
	if (!inMain(parent)){
		if(parent._bPretest == true){
		  	//yes we are, do we have a valid section, and a valid question
		 
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives){
		  		// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				// see what type of question we have
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// submit not pressed, turn on the warning message
					_bSubmitWarning = true;
					// redisplay the next page
					gotoPage();
				
					// return to avoid going to the next page
					return false;
				}
			}
			//it is, is the section initialized
			if(_nSectionCurrent == -1){ 
				//it isn't increment the section count
				_nSectionCurrent++;	
				//_nQuestionCurrent++;
			}
			
			//have we asked all the questions for a section
			if(_nQuestionCurrent == Number(test[_nSectionCurrent].pool.length -1)){
				//yes, is this the last section
				_nSectionCurrent++;
				//reset the current question
				_nQuestionCurrent = -1;
						
			}
			_nQuestionCount++;
			// increment the question count
			_nQuestionCurrent++;
	
			// go to the next page
			gotoPage();
		//This is a Course Test-Out, Not an Pretest (content) Test Out. 
		}else{
			// see if we are on a question page
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives)  {
				// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				// see what type of question we have
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// submit not pressed, turn on the warning message
					_bSubmitWarning = true;
					
					// redisplay the next page
					gotoPage();
				
					// return to avoid going to the next page
					return false;
				}
			}
			
			// increment the section count
			_nSectionCurrent++;
			
			// go to the next page
			gotoPage();
		}
	}else{
		// see if we are in the post test
		if(parent._bPosttest){
			// see if we are on a question page
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives)  {
				// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				// see what type of question we have
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// submit not pressed, turn on the warning message
					_bSubmitWarning = true;
					//_nQuestionCount++;
					// redisplay the next page
					gotoPage();
				
					// return to avoid going to the next page
					return false;
				}
			}
			
			//Is the section initialized
			if(_nSectionCurrent == -1){ 
				// Hide Welcome Button
				if(parent.document.getElementById("Welcome"))
					parent.document.getElementById("Welcome").style.display = "none";
				//it isn't increment the section count
				setNextSection();
			}
		
			//have we asked all the questions for a section
			if(_nQuestionCurrent == test[_nSectionCurrent].pool.length -1){
				//yes, is this the last section
				setNextSection();
				//reset the current question
				_nQuestionCurrent = -1;
						
			}
			
			_nQuestionCount++;
			// increment the question count
			_nQuestionCurrent++;
			
			// go to the next page
			gotoPage();
			
			return false;
		}else{
			// see if we are on a question page
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives)  {
				// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				// see what type of question we have
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// submit not pressed, turn on the warning message
					_bSubmitWarning = true;
					_nQuestionCount++;
					// redisplay the next page
					gotoPage();
				
					// return to avoid going to the next page
					return false;
				}
			}
			// increment the section count
			//_nSectionCurrent++;
			setNextSection();
			
			// go to the next page
			gotoPage();
		}
	}
	return false;
}

/***
* Called when the Previous button is clicked.
***/
function PrevPage() {
		
	//_bSubmitWarning - see if we have already warned the user about submitting
	if (_bSubmitWarning) {
		// we have warned, remove the response
		_oQuestion.response = "";
		
		// turn off the warning
		_bSubmitWarning = false;
		
		if (!inMain(parent)){
			// is this a pretest
			if(parent._bPretest == true){
				//it is
				//are we in the first section
			
				// see if we are at the first question of the first section
				if(_nSectionCurrent == 0 && _nQuestionCurrent ==0){
					// we are, reset all the counters and index and go to the intro
					_nSectionCurrent = -1;
					_nQuestionCurrent = -1;
					_nQuestionCount--;
					gotoPage();
					return false;
				}
			
				//are we at the first question
				if(_nQuestionCurrent == 0){
					//yes, decrement the section count
					_nSectionCurrent--;
					
					//reset the current question to the last in the pool of the new section
					_nQuestionCurrent = test[_nSectionCurrent].pool.length;			
				}
				
				// decrement the question count
				_nQuestionCurrent--;
				
				// go to the previous page in the section
				_nQuestionCount--;
				
			//it isn't a pretest
			}else{
				//increment the question count
				_nSectionCurrent--;
			}
		}else{
				//increment the question count
				//_nSectionCurrent--;
				setPreviousSection();
		}

		// go to the next page
		gotoPage();
	
		return false;
	}//_bSubmitWarning	
	
	if (!inMain(parent)){
		//Prev - Are we in pretest mode
		if(parent._bPretest == true){
		  	//yes we are, do we have a valid section, and a valid question
		 
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives){
		  		// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				// see what type of question we have
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// submit not pressed, turn on the warning message
					_bSubmitWarning = true;
					
					// redisplay the next page
					gotoPage();
				
					// return to avoid going to the next page
					return false;
				}
			}
			
			// see if we are at the first question of the first section
			if(_nSectionCurrent == 0 && _nQuestionCurrent ==0){
				// we are, reset all the counters and index and go to the intro
				_nSectionCurrent = -1;
				_nQuestionCurrent = -1;
				_nQuestionCount--;
				gotoPage();
				return false;
			}
		
			//are we at the first question
			if(_nQuestionCurrent == 0){
				//yes, decrement the section count
				_nSectionCurrent--;
				
				//reset the current question to the last in the pool of the new section
				_nQuestionCurrent = test[_nSectionCurrent].pool.length;			
			}
			
			// decrement the question count
			_nQuestionCurrent--;
			
			// go to the previous page in the section
			_nQuestionCount--;
			gotoPage();
		
		}else{
			// see if we are on a question page
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives) {
				// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				/* see what type of question we have */
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// no submit, see if we have already warned the user about submitting
					if (!_bSubmitWarning) {
						// we have not, turn on the warning message
						_bSubmitWarning = true;
						
						// redisplay the next page
						gotoPage();
					
						// return to avoid going to the next page
						return false;
					}
				}
			}
		
			// decrement the section count
			_nSectionCurrent--;
			
			if(parent._bPosttest && _nSectionCurrent == -1){
				// Show Welcome Button
				if(parent.document.getElementById("Welcome"))
					parent.document.getElementById("Welcome").style.display = "block";
			}
			// go to the new page
			gotoPage();
		}
	}else{
		// see if we are in a post test
		if(parent._bPosttest){
			// see if we are on a question page
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives) {
				// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				/* see what type of question we have */
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// no submit, see if we have already warned the user about submitting
					if (!_bSubmitWarning) {
						// we have not, turn on the warning message
						_bSubmitWarning = true;
						
						// redisplay the next page
						gotoPage();
					
						// return to avoid going to the next page
						return false;
					}
				}
			}
		// seeif current tested out section == 0 and the current question in that section is 0
			if((getNonTestedOutQuestionNumber()-1) == 0 && _nQuestionCurrent == 0){
				// they are, so reset the variables so that we will navigate to the intro page
				_nSectionCurrent = -1;
				_nQuestionCurrent = -1;
				_nQuestionCount--;
				// we are going to the intro page so show the Welcome button
				if(parent.document.getElementById("Welcome"))
					parent.document.getElementById("Welcome").style.display = "block";
				gotoPage();
				return false;
			}
		
			//are we at the first question
			if(_nQuestionCurrent == 0){
				//yes, decrement the section count
				setPreviousSection();
				
				//reset the current question to the last in the pool of the new section
				_nQuestionCurrent = test[_nSectionCurrent].pool.length;			
			}
			
			// decrement the question count
			_nQuestionCurrent--;
			
			// go to the previous page in the section
			_nQuestionCount--;
	
			// go to the new page
			gotoPage();
		}else{
			// see if we are on a question page
		  	if (_nSectionCurrent > -1 && _nSectionCurrent < _nObjectives) {
				// we are, we want to see if there was a response to the question so define this variable
				var bResponse;
				
				/* see what type of question we have */
				if (_oQuestion.type == "true-false") {
					bResponse = evalTrueFalse(false);
				} else if (_oQuestion.type == "choice") {
					bResponse = evalChoice(false);
				} else if (_oQuestion.type == "choice-multiple") {
					bResponse = evalChoiceMultiple(false);
				} else if (_oQuestion.type == "fill-in") {
					bResponse = evalFillIn(false);
				} else if (_oQuestion.type == "matching") {
					bResponse = evalMatching(false);
				}
				
				// see if submit was pressed
				if (!bResponse) {
					// no submit, see if we have already warned the user about submitting
					if (!_bSubmitWarning) {
						// we have not, turn on the warning message
						_bSubmitWarning = true;
						
						// redisplay the next page
						gotoPage();
					
						// return to avoid going to the next page
						return false;
					}
				}
			}
		
			// decrement the section count
			//_nSectionCurrent--;
			setPreviousSection();
	
			// go to the new page
			gotoPage();	
		}
	}
	return false;
}


/***
* goto the passed page index
***/
function gotoPage() {
	/* see if we have initialized the start time */
	if (_dateStart == null) {
		/* we have not, initialize it */
		_dateStart = new Date();
		_timeStart = _dateStart.getTime();
	}
	
	/* see if there is a time limit set */
	if (timeLimit > 0) {
		/* there is, see if we have started the timer */
		if (_timerTest == null) {
			/* we have not, set the time limit for the test in milleseconds */
			_timeLimitMS = timeLimit * 60000;

			/* get the total time spent in this SCO from prior sessions */
			var sTime = getTotalTime();
			_timeLimitMS -= ISODurationToMillisec(sTime);
			/* set a time to update the time limit */
			_timerTest = setInterval("timeCheck()", 1000);
		}
	}

	/* display the appropriate page */
	displayPage();
}

/***
* goto a specific section
*	nSection - the section index
***/
function gotoQuestion(nSection,nQuestion) {
	// see if we have already warned the user about submitting
	if (_bSubmitWarning) {
		// we have warned, remove the response
		_oQuestion.response = "";
		
		// turn off the warning
		_bSubmitWarning = false;
	}
	
	// change the section number
	_nSectionCurrent = Number(nSection - 0);
	
	//are we in a test-out
	if(!inMain(parent)){
		//yes, are we in a pre-test 
		if(parent._bPretest == true){
			//init temp variable for question number
			var nQNum = 0;
			//set value for question index in pool
			_nQuestionCurrent = nQuestion - 0;
			
			//calculate current question number based on current section and question selected in pool.
			
			//loop thru all sections up to the currently selected session
			for(var i=0; i <= _nSectionCurrent; i++){
				//if we it our current session we want the value of the current question in the pool
				if(i == _nSectionCurrent){
					//add the number of questions to the temp variable
					nQNum += Number(_nQuestionCurrent + 1);
					continue;
				}
				//for all other sections that come before our current section, add the number for all questions in the pool.	
				nQNum += test[i].pool.length;
					
			}
			//the total number of questions from all preceeding sections, plus the # of questions up to the currently selected is the question count.
			_nQuestionCount = nQNum;
		}
	}else if(parent._bPosttest){
		
		var nQNum = 0;
		//set value for question index in pool
		_nQuestionCurrent = nQuestion - 0;
		
		//calculate current question number based on current section and question selected in pool.
		
		//loop thru all sections up to the currently selected session
		for(var i=0; i <= _nSectionCurrent; i++){
			//if we it our current session we want the value of the current question in the pool
			if(i == _nSectionCurrent){
				//add the number of questions to the temp variable
				nQNum += Number(_nQuestionCurrent + 1);
				continue;
			}
			// see if this section has been tested out of and if we are hiding tested out questions
			if(test[i].testedOut == '1' && !parent._sPT_RequirePassedObjectives)
				// it has, do not add it to the total
				continue;
				
			//for all other sections that come before our current section, add the number for all questions in the pool.	
			nQNum += test[i].pool.length;
				
		}
		//the total number of questions from all preceeding sections, plus the # of questions up to the currently selected is the question count.
		_nQuestionCount = nQNum;
	}
	
	// display the question for that section
	displayPage();
}

/***
* Get the page number
***/
function getPageNumber() {
	var sDisplay;
	
	if (!inMain(parent)){
		//Prev - Are we in pretest mode
		if(parent._bPretest == true){
			// build the page display and return it
			sDisplay = XsMsgPageNum.replace(/%%complete/g,getComplete());
			sDisplay = sDisplay.replace(/%%total/g,_nQuestions);
			sDisplay = sDisplay.replace(/%%question/g,(_nQuestionCount));
		}else{
			// build the page display and return it
			sDisplay = XsMsgPageNum.replace(/%%complete/g,getComplete());
			sDisplay = sDisplay.replace(/%%total/g,_nObjectives);
			sDisplay = sDisplay.replace(/%%question/g,(_nSectionCurrent+1));
		}
	}else{
		if(parent._bPosttest){
			var nTotal = getNonTestedOutQuestionTotal();
			var nCurrent = _nQuestionCount;
			
			// build the page display and return it
			//sDisplay = XsMsgPageNum.replace(/%%complete/g,getComplete());
			//sDisplay = sDisplay.replace(/%%total/g, nTotal);
			//sDisplay = sDisplay.replace(/%%question/g,nCurrent);
			
			// add more space bu not showing the quesiton number
			sDisplay = "";
		}else{
			var nTotal = _nObjectives;
			var nCurrent = _nSectionCurrent+1;
		
			nTotal = getNonTestedOutQuestionTotal();
			nCurrent = getNonTestedOutQuestionNumber();
			
			// build the page display and return it
			//sDisplay = XsMsgPageNum.replace(/%%complete/g,getComplete());
			//sDisplay = sDisplay.replace(/%%total/g, nTotal);
			//sDisplay = sDisplay.replace(/%%question/g,nCurrent);
			
			// add more space bu not showing the quesiton number
			sDisplay = "";
		}
		
	}
	
	
	// see if we need to show optional/required modules
	if (parent._bShowOptional && inMain(parent)) {
		// we do, get the module number
		var nMod = parent._sPageCurrent.substring(0,parent._sPageCurrent.indexOf("_")) - 1;
		
		// see which word to show
		if (parent._aModRequired[nMod]) {
			// required
			var sType = '';
		} else {
			// optional
			var sType = '<span class="pageOptional" title="' + parent._sOptionalExplanation + '"> (' + parent._sOptional + ')</span>';
		}
	} else {
		// none
		var sType = '';
	}
	
	// build the complete intro string (if used)
	if (sDisplay != "") sDisplay += sType;
	
	return sDisplay;
}


/***
* Show the current Page to the learner
****/
function displayPage() {
	// see if we are showing a submit warning
	if (!_bSubmitWarning) {
		// we are not, so save the state
		saveCurrentState();
		// see if we are in test out mode
		if (!inMain(parent)) {
			//if we are not in a pretest
			if(!parent._bPretest){
				// we are, call cal score to make sure we have not counted unsubmitted answers
				calcScore();

				// see if the learner has failed too many questions AND we have not warned
				if (_nIncorrect > _nObjectives -_nRequiredCorrect && !_bWarnedFailed) {
					// he has, see if this is an ILT test out
					if (parent._bIsILTTestOut) {
						// it is, see if he wants to quit
						if (confirm(XsFailWarningILT)) {
							// he does, navigate there
							if (parent.ExitCourse)
								parent.ExitCourse();
							return;
						} else {
							// learner has been warned, do not warn again
							_bWarnedFailed = true;
						}
					} else {
						//see if he wants to go to the course
						if (confirm(XsFailWarning)) {
							// he does, kill off the knowledge check data
							if (parent.setState) {
								parent.setState("CYK", "");
								parent.setBookmark("");
							}
							
							// navigate to the course
							if (parent.gotoPage)
								parent.gotoPage("../../Course.htm");
							return;
						} else {
							// learner has been warned, do not warn again
							_bWarnedFailed = true;
						}
					}
				}
			}else{
				//we are in a pretest, calculate the score and the passed objectives
				calcPretest();	
			}
		}
	}
	
	if (!inMain(parent)&& parent._bPretest) {
		// see if this is the intro page
		if (_nSectionCurrent == -1 && _nQuestionCurrent == -1) {
			// it is, show the introduction page and quit
			_nQuestionCount = 0;
			showIntro();
			return;
		}
		//are we at the last section
		if (_nSectionCurrent == _nObjectives){
			showResults();
			return;
		}	
	}else{
		if(parent._bPosttest){			
			// see if this is the intro page
			if (_nSectionCurrent == -1 && _nQuestionCurrent == -1) {
				// it is, show the introduction page and quit
				_nQuestionCount = 0;
				showIntro();
				return;
			}

			// see if this is the last question in the last section
			if (_nSectionCurrent == _nObjectives && _nQuestionCurrent == (test[_nSectionCurrent-1].pool.length-1)) {
				// it is show it and quit
				showResults();
				return;
			}	
		}
		
		// see if this is the intro page
		if (_nSectionCurrent == -1) {
			// it is, show the introduction page and quit
			showIntro();
			return;
		}
		
		if (_nSectionCurrent == _nObjectives) {
			// it is show it and quit
			showResults();
			return;
		}	
		
	}

	// not the intro, we are showing a section, randomly select a question from the next section
	_oQuestion = selectQuestionFromPool();

	/* see what type of question we have */
	if (_oQuestion.type == "true-false") {
		showTrueFalse();
	} else if (_oQuestion.type == "choice") {
		showChoice();
	} else if (_oQuestion.type == "choice-multiple") {
		showChoiceMultiple();
	} else if (_oQuestion.type == "fill-in") {
		showFillIn();
	} else if (_oQuestion.type == "matching") {
		showMatching();
	}
	
}

/***
* Show the next question in the section
****/
function anotherQuestion() {
	// the _aOrder array tells us the actual section to select, so get the section from that array
	// we use the _aOrder array to randomize the sections
	var nIndex = _aOrder[_nSectionCurrent];

	// see if the currently selected question is the last question in the pool
	if (test[nIndex].selected < (test[nIndex].pool.length - 1) ) {
		// it is, increment the selected value
		test[nIndex].selected++;
	} else {
		// we are at the end of the pool, restart from the beginning
		test[nIndex].selected = 0;
		
		// loop through the pool
		for (var i=0; i<test[nIndex].pool.length; i++) {
			// delete the previous responses for each question
			test[nIndex].pool[i].response = "";
			
			// reset the attempts
			test[nIndex].pool[i].attempts = 0;
		}
	}

	// redisplay the question
	displayPage();
}

/***
* User wants to retake the test
****/
function retakeTest() {

	// loop through the sections to get the first incorrect or unanswered question
	for (var i=0; i<_nObjectives; i++) {
		// the _aOrder array tells us the actual section to select, so get the section from that array
		// we use the _aOrder array to randomize the sections 
		var nIndex = _aOrder[i];
		
		// get the selected question
		var nSelected = test[nIndex].selected;
		
		// see if the selected question is unanswered or incorrect
		if (test[nIndex].pool[nSelected].response != test[nIndex].pool[nSelected].answer) {
			// we found the first incorrect question, reset the current section and break out
			_nSectionCurrent = i;
			break;
		}
	}
	
	// loop through the sections - we will switch the question for all incorrect answers
	for (i=0; i<_nObjectives; i++) {
		// get the selected question
		nSelected = test[i].selected;
		
		// see if this question has a response
		if (test[i].pool[nSelected].response != "") {
			// it does, see if it has an incorrect answer
			if (test[i].pool[nSelected].response != test[i].pool[nSelected].answer) {
				// it does, see if the currently selected question is the last question in the pool
				if (test[i].selected < (test[i].pool.length - 1)) {
					// it is not, increment the selected question
					test[i].selected++;
				} else {
					// it is the last question in the pool, restart from the beginning
					test[i].selected = 0;
					
					// loop through the pool - we will erase all previous responses
					for (var j=0; i<test[i].pool.length; j++) {
						// delete the previous responses for each question
						test[i].pool[j].response = "";
						
						// reset the attempts
						test[i].pool[j].attempts = 0;
					}
				}
			}
		}
	}
	
	// display the first incorrect question from this section
	displayPage();
}

/**
* show the timeout page
*/
function showTimeoutAlert() {
	/* update the time display */
	document.getElementById("timeLimit").innerHTML = XsMsgTime + "0";

	/* replace variables in the time out strings */
	XsMsgTimeout = XsMsgTimeout.replace(/%%complete/g,getComplete());
	XsMsgTimeout = XsMsgTimeout.replace(/%%total/g,_nObjectives);
	XsMsgTimeout = XsMsgTimeout.replace(/%%score/g,((parent._bPosttest) ? calcPosttest() : calcScore()));
	XsTimeoutAlert = XsTimeoutAlert.replace(/%%complete/g,getComplete());
	XsTimeoutAlert = XsTimeoutAlert.replace(/%%total/g,_nObjectives);
	XsTimeoutAlert = XsTimeoutAlert.replace(/%%score/g,((parent._bPosttest) ? calcPosttest() : calcScore()));
	
	/* redisplay the page so the timeout alert is shown */
	displayPage();
	
	/* tell the learner he/she has run out of time */
	alert(XsTimeoutAlert);
}

/***
* show the introduction page
***/
function showIntro(){
	// add the legend to the intro page
	var s = _sIntroPage;
	s += '<div id="Legend">';
	s += '<div>' + XsQitemTitle + '</div>';
	
	s += '<div id="LegendKCStatus"><table width=130 cellpadding="0" cellspacing="2" border="0"><tr>';
	s += '<td width="26" align="center"><img src="../../Template/Images/legend-q1.png" border="0" alt="'+ XsLegendQ1Ex +'" /></td>';
	s += '<td width="26" align="center"><img src="../../Template/Images/legend-q2.png" border="0" alt="'+ XsLegendQ2Ex +'" /></td>';
	s += '<td width="26" align="center"><img src="../../Template/Images/legend-q3.png" border="0" alt="'+ XsLegendQ3Ex +'" /></td>';
	s += '<td width="26" align="center"><img src="../../Template/Images/legend-q4.png" border="0" alt="'+ XsLegendQ4Ex +'" /></td>';
	s += '<td width="26" align="center"><img src="../../Template/Images/legend-q5.png" border="0" alt="'+ XsLegendQ5Ex +'" /></td>';
	s += '</tr></table></div>';
	
	s += '<div>';
	s += '  <table border="0">';
	s += '    <tr>';
	s += '      <td class="LegendLabel" style="padding-top:5px;">' + XsLegendLabel + '</td>';
	s += '      <td style="padding-top:5px;"><img src="../../Template/Images/legend-cross.png" alt="' + XsLegendIncorrect + '" width="18" height="18" /></td>';
	s += '      <td style="padding-top:5px;"> = ' + XsLegendIncorrect + '</td>';
	s += '      <td style="padding-top:5px;"><img src="../../Template/Images/legend-visited.png" alt="' + XsLegendVisited + '" width="17" height="18" /></td>';
 	s += '      <td style="padding-top:5px;"> = ' + XsLegendVisited + '</td>';
	s += '    </tr>';
	s += '    <tr>';
	s += '      <td>&nbsp;</td>';
	s += '      <td><img src="../../Template/Images/legend-tick.png" alt="' + XsLegendCorrect + '" width="18" height="18" /></td>';
	s += '      <td> = ' + XsLegendCorrect + '</td>';
	s += '      <td><img src="../../Template/Images/legend-current.png" alt="' + XsLegendCurrent + '" width="17" height="23" /></td>';
	s += '      <td> = ' + XsLegendCurrent + '</td>';
	s += '    </tr>';
	s += '    <tr>';
	s += '      <td>&nbsp;</td>';
	s += '      <td><img src="../../Template/Images/legend-not-attempted.png" alt="' + XsLegendNotAttempted + '" width="18" height="18" /></td>';
	s += '      <td> = ' + XsLegendNotAttempted + '</td>';
	s += '      <td><img src="../../Template/Images/legend-not-visited.png" alt="' + XsLegendNotVisited + '" width="17" height="18" /></td>';
	s += '      <td> = ' + XsLegendNotVisited + '</td>';
	s += '    </tr>';
	s += '  </table>';
	s += '</div>';
	s += '</div>';
	
	/* show the information page HTML */
	document.getElementById("question").innerHTML = '<div class="introduction">' + s + '</div><form>' + navButtons() + '</form>';
	
	// hide the question menu
	document.getElementById("questionList").innerHTML = "&nbsp;";
	
	// hide the test status info
	document.getElementById("testStatus").innerHTML = "&nbsp;";
}

/***
* show the results page
***/
function showResults(){
	var isTestOut = false;
	// see if the learner has a passing score
	if (_nTotalScore >= Math.round(_nPassingScore)) {
		//we have tested out
		isTestOut = true;
		// he does, add the passing results
		if(parent._bPosttest){
			var sData = _sResultsPassing.replace(/%%p/g,Math.round(_nTotalScore));
			sData = sData.replace(/%%s/g,parent._sPT_MinScore);
			sData = sData.replace(/%%r/g,(parent._sPT_MaxAttempts == 0 ? XsIntroPostTestNoLimit : ""+(parent._sPT_MaxAttempts - _nPosttestAttempts)));
		}else{
			var sData = _sResultsPassing.replace(/%%score/g,Math.round(_nTotalScore));
			sData = sData.replace(/%%pass/g,Math.round(_nPassingScore));
		}
	} else {
		// he does not have a passing score, see if he can get a passing score
		if (_nIncorrect > _nObjectives -_nRequiredCorrect) {
			// he can NOT pass, tell him he failed
			if(parent._bPosttest){
				var sData = _sResultsFailing.replace(/%%p/g,Math.round(_nTotalScore));
				sData = sData.replace(/%%s/g,parent._sPT_MinScore);
				sData = sData.replace(/%%r/g,(parent._sPT_MaxAttempts == 0 ? XsIntroPostTestNoLimit : ""+(parent._sPT_MaxAttempts - _nPosttestAttempts)));
			}else{
				var sData = _sResultsFailing.replace(/%%score/g,Math.round(_nTotalScore));
				sData = sData.replace(/%%pass/g,Math.round(_nPassingScore));
			}
		} else {
			// not passed or failed, tell him the test is incomplete
			if(parent._bPosttest){
				var sData = _sResultsIncomplete.replace(/%%p/g,Math.round(_nTotalScore));
				sData = sData.replace(/%%s/g,parent._sPT_MinScore);
				sData = sData.replace(/%%r/g,(parent._sPT_MaxAttempts == 0 ? XsIntroPostTestNoLimit : ""+(parent._sPT_MaxAttempts - _nPosttestAttempts)));
			}else{
				var sData = _sResultsIncomplete.replace(/%%score/g,Math.round(_nTotalScore));
				sData = sData.replace(/%%pass/g,Math.round(_nPassingScore));
			}
		}
	}
	
	//dispay test out results
	//are we in a test-out
	if(!inMain(parent)){
		//yes, are we in a pretest
		if(parent._bPretest){
			//yes, get the required objectives for the selected tracks
			var aObjsByTracks = _aObjState.removeDuplicate();
						
			//have we tested out of objectives
			if(aObjsByTracks.length > 0){			
				//yes we have, store the state in the _oObjectives collection
				for(i=0;i<aObjsByTracks.length;i++){
					parent._oObjectives.Item(aObjsByTracks[i]).state = 2;
				}
			}
			
			//based on the tested out objectives, get modules we've tested out of because we've tested out of the KC
			var aModTested = parent.getTestOutModules();
	
			//based on the tested out objectives, get the post test module if it has been tested out of.
			var aPostTested = new Array();
			parent._bPosttest = true;
			aPostTested = parent.getTestOutPosttest();
			parent._bPosttest = false;
			//try to display the results
			
			/*Scenario 1 - We have tested out of the course, but we haven't passed any objectives, or tested out of modules.*/
			if(isTestOut == true && aObjsByTracks.length <= 0 && aModTested.length <= 0){
				sData += XsPretestScene1Results
			/*Scenario 2 - We have failed to test out, we haven't passed objectives, we haven't tested out of modules.*/	
			}else if(isTestOut == false && aObjsByTracks.length <= 0 && aModTested.length <= 0){
				sData += XsPretestScene2Results	
			/*Scenario 3 - We have tested out of the course, and we have passed objectives and tested out of modules.*/	
			}else if(isTestOut == true && aObjsByTracks.length > 0 && aModTested.length > 0){
				sData += XsPretestScene3Results	
			/*Scenario 4 - We have failed to test out, but we pass objectives and test out of modules.*/	
			}else if(isTestOut == false && aObjsByTracks.length > 0 && aModTested.length > 0){
				sData += XsPretestScene4Results
			/*Scenario 5 - We have tested out of the course, we have passed objectives, but haven't tested out of modules.*/	
			}else if(isTestOut == true && aObjsByTracks.length > 0 && aModTested.length <= 0){
				sData += XsPretestScene5Results		
			/*Scenario 6 - We have failed to tested out, we have passed objectives, but haven't tested out of modules.*/	
			}else if(isTestOut == false && aObjsByTracks.length > 0 && aModTested.length <= 0){
				sData += XsPretestScene6Results	
			}else{
				alert('Results Error');
			}
			

			
			if(aObjsByTracks.length > 0){
				if(aModTested.length > 0){
					sData += '<table cellpadding="5" cellspacing="0">';
					for(var i=0;i<aModTested.length;i++){
						sData += '<tr><td valign="top" align="center"><img src="../../Template/Images/kc-correct.png"/></td><td>'+ aModTested[i] +'</td></tr>';
					}

					//if the pertest has been tested out of, display that module name
					if(aPostTested.length > 0){
						for(var i=0;i<aPostTested.length;i++){
							sData += '<tr><td valign="top" align="center"><img src="../../Template/Images/kc-correct.png"/></td><td>'+ aPostTested[i] +'</td></tr>';
						}
					}
					
					sData += '</table><br/><br/>';
					
				}		
			}		
		}
	}

	// add the nav buttons
	sData += '<form>' + navButtons() + '</form>';
	
	// insert the results
	document.getElementById("question").innerHTML = '<div class="results">' + sData + '</div>';
	
	// show the sumary information
	showSummary();
}

function addGotoCourse() {
	var s = "";
	
	// see if this is the test out
	if (!inMain(parent)) {
		// it is, build the go to course button
		s = '<div><a href="../../Course.htm" onclick="parent.gotoPage(this.href); return false;" onKeyPress="parent.gotoPage(this.href); return false;">' + parent._sCourseLink + '</a></div>';
	}
	
	
	return s;
}

/***
* show the summary info
***/
function showSummary() {
	var sData;
	var sRetake = "";
	
	// see if we are are showing the testout
	if (!inMain(parent)) {
		// see if we are in a pretest
		if(parent._bPretest == true){
			// we are, use the test out message
			var sSummaryPassed = XsSummaryPassedTestout;
			var sSummaryFailed = XsSummaryFailedTestout;	
		}else{
			// we are, use the test out message
			var sSummaryPassed = XsSummaryPassedTestout;
			var sSummaryFailed = XsSummaryFailedTestout;
		}
		
		// we are, use the test out message
		var sSummaryPassed = XsSummaryPassedTestout;
		var sSummaryFailed = XsSummaryFailedTestout;
	
	
	} else {
		// see if we are in the post test
		if(parent._bPosttest){
			// See if the course has already been completed
			if(parent.isComplete()){
				var sSummaryPassed = XsSummaryPostTestCompleted;
				var sSummaryFailed = XsSummaryPostTestCompleted;
			// see if user has exhausted their attempts
			}else if(parent._sPT_MaxAttempts > 0 && _nPosttestAttempts >= parent._sPT_MaxAttempts){
				var sSummaryPassed = XsSummaryPostTestPassed;
				var sSummaryFailed = XsSummaryPostTestNoAttempts;
			}else{
				var sSummaryPassed = XsSummaryPostTestPassed;
				var sSummaryFailed = XsSummaryPostTestIncomplete;	
			}	
		}else{
			// a knowledge check, see if the learner must answer all
			if (_bMustAnswerAll) {
				// he should, use those messages
				var sSummaryPassed = XsSummaryPassedMust;
				var sSummaryFailed = XsSummaryFailedMust;
			} else {
				// use the regular messages
				var sSummaryPassed = XsSummaryPassed;
				var sSummaryFailed = XsSummaryFailed;
			}
		}
	}	
	
	if (!inMain(parent)) {
		// see if we are in a pretest
		if(parent._bPretest){
			var nScore = calcPretest();
		}else{
			var nScore = calcScore();
		}
	}else{
		// see if we are in the post test
		if(parent._bPosttest){
			var nScore = calcPosttest();
		}else{
			/* get the score */
			var nScore = calcScore();
		}
	}
	
	
	if (!inMain(parent)) {
		// see if we are in a pretest
		if(parent._bPretest){
			// see if the learner has passed the test - two possible criteria
			// 1. do not have to answer all AND score > passing
			// 2. do have to answer all AND all answered
			//if ((!_bMustAnswerAll && nScore >= _nPassingScore) || (_bMustAnswerAll && _nAnswered == _nObjectives)) {
			if (nScore >= Math.round(_nPassingScore)) {
				/* he has, the test is complete */
				sData = sSummaryPassed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,_nCorrect);
				// replace total number of questions to work in the pretest and KC
				sData = sData.replace(/%%total/g,_nQuestions);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,_nAnswered);
				
				// set to passed
				_sPassStatus = "P";
			} else if (nScore < _nPassingScore){
				/* he has not, tell him */
				sData = sSummaryFailed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,_nCorrect);
				//sData = sData.replace(/%%total/g,_nObjectives);
				sData = sData.replace(/%%total/g,_nQuestions);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,_nAnswered);
				
				_sPassStatus = "I";
				
				// see if the user has failed - can only fail if not have to answer all
				/*if (!_bMustAnswerAll && _nIncorrect > _nObjectives - _nRequiredCorrect) {
					// failed, mark as failed
					_sPassStatus = "F";
				} else {
					// not failed, mark as incomplete
					_sPassStatus = "I";
				}*/
			}
		}else{
			// see if the learner has passed the test - two possible criteria
			// 1. do not have to answer all AND score > passing
			// 2. do have to answer all AND all answered
			if ((!_bMustAnswerAll && nScore >= Math.round(_nPassingScore)) || (_bMustAnswerAll && _nAnswered == _nObjectives)) {
				/* he has, the test is complete */
				sData = sSummaryPassed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,_nCorrect);
				sData = sData.replace(/%%total/g,_nObjectives);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,_nAnswered);
				
				// set to passed
				_sPassStatus = "P";
			} else {
				/* he has not, tell him */
				sData = sSummaryFailed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,_nCorrect);
				sData = sData.replace(/%%total/g,_nObjectives);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,_nAnswered);
				
				// see if we want to allow a retake
				if (_bAllowRetake) {
					// we do, create a retake the test button
					sRetake = "<div class='TestStatusRetake'><a href='#' onclick='retakeTest();return false'>" + XsTestStatusRetake + "</a></div>";
				}
				
				// see if the user has failed - can only fail if not have to answer all
				if (!_bMustAnswerAll && _nIncorrect > _nObjectives - _nRequiredCorrect) {
					// failed, mark as failed
					_sPassStatus = "F";
				} else {
					// not failed, mark as incomplete
					_sPassStatus = "I";
				}
			}	
		}
	}else{
		if(parent._bPosttest){
			// Need to adjust variable values if a pre test has been taken and the user tested out of some sections
			var nNTOCorrect = _nCorrect;
			var nNTOTotal = _nObjectives;
			var nNTOAnswered = _nAnswered;
			
			// Get the total of non-tested out questions
			nNTOTotal = getNonTestedOutQuestionTotal();
			// Reset the correct number to exclude tested out questions
			nNTOCorrect = _nCorrect - (_nQuestions - nNTOTotal);
			// make sure user doesn't see a negative number
			if(nNTOCorrect < 0)
				nNTOCorrect = 0;
			// Reset answered to excluded tested out questions
			nNTOAnswered = _nAnswered - (_nQuestions - nNTOTotal);
			// make sure user doesn't see a negative number.
			if(nNTOAnswered < 0)
				nNTOAnswered = 0;		
				
				
			// see if the learner has passed the test - two possible criteria
			// 1. do not have to answer all AND score > passing
			// 2. do have to answer all AND all answered
			if ((!_bMustAnswerAll && nScore >= _nPassingScore) || (_bMustAnswerAll && nNTOAnswered == nNTOTotal)) {
				/* he has, the test is complete */
				sData = sSummaryPassed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,nNTOCorrect);
				sData = sData.replace(/%%total/g,nNTOTotal);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,nNTOAnswered);
				
				// set to passed
				_sPassStatus = "P";
			} else {
				/* he has not, tell him */
				sData = sSummaryFailed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,nNTOCorrect);
				sData = sData.replace(/%%total/g,nNTOTotal);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,nNTOAnswered);
				
				// see if we want to allow a retake
				if (_bAllowRetake) {
					// we do, create a retake the test button
					sRetake = "<div class='TestStatusRetake'><a href='#' onclick='retakeTest();return false'>" + XsTestStatusRetake + "</a></div>";
				}
				
				// see if the user has failed - can only fail if not have to answer all
				if (!_bMustAnswerAll &&  parent._sPT_MaxAttempts > 0 && _nPosttestAttempts >= parent._sPT_MaxAttempts && _nIncorrect > (_nQuestions - _nRequiredCorrect)) {
					// failed, mark as failed
					_sPassStatus = "F";
				} else {
					// not failed, mark as incomplete
					_sPassStatus = "I";
				}
			}
		}else{
			// Need to adjust variable values if a pre test has been taken and the user tested out of some sections
			var nNTOCorrect = _nCorrect;
			var nNTOTotal = _nObjectives;
			var nNTOAnswered = _nAnswered;
			
			// Get the total of non-tested out questions
			nNTOTotal = getNonTestedOutQuestionTotal();
			// Reset the correct number to exclude tested out questions
			nNTOCorrect = _nCorrect - (_nObjectives - nNTOTotal);
			// make sure user doesn't see a negative number
			if(nNTOCorrect < 0)
				nNTOCorrect = 0;
			// Reset answered to excluded tested out questions
			nNTOAnswered = _nAnswered - (_nObjectives - nNTOTotal);
			// make sure user doesn't see a negative number.
			if(nNTOAnswered < 0)
				nNTOAnswered = 0;		
			// see if the learner has passed the test - two possible criteria
			// 1. do not have to answer all AND score > passing
			// 2. do have to answer all AND all answered
			if ((!_bMustAnswerAll && nScore >= _nPassingScore) || (_bMustAnswerAll && _nAnswered == _nObjectives)) {
				/* he has, the test is complete */
				sData = sSummaryPassed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,nNTOCorrect);
				sData = sData.replace(/%%total/g,nNTOTotal);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,nNTOAnswered);
				
				// set to passed
				_sPassStatus = "P";
			} else {
				/* he has not, tell him */
				sData = sSummaryFailed.replace(/%%score/g,Math.round(nScore));
				sData = sData.replace(/%%correct/g,nNTOCorrect);
				sData = sData.replace(/%%total/g,nNTOTotal);
				sData = sData.replace(/%%pass/g,_nPassingScore);
				sData = sData.replace(/%%complete/g,nNTOAnswered);
				
				// see if we want to allow a retake
				if (_bAllowRetake) {
					// we do, create a retake the test button
					sRetake = "<div class='TestStatusRetake'><a href='#' onclick='retakeTest();return false'>" + XsTestStatusRetake + "</a></div>";
				}
				
				// see if the user has failed - can only fail if not have to answer all
				if (!_bMustAnswerAll && _nIncorrect > _nObjectives - _nRequiredCorrect) {
					// failed, mark as failed
					_sPassStatus = "F";
				} else {
					// not failed, mark as incomplete
					_sPassStatus = "I";
				}
			}
		}
			
	}
	// make sure we are not in the post test before displaying progress.
	if(!parent._bPosttest){
		// show the test status info
		document.getElementById("testStatus").innerHTML = "<div class='TestStatusTitle'>" + XsTestStatusTitle + "</div>" + 
															"<div class='TestStatusRequired'>" + _sRequired + "</div>" + 
															"<div class='TestStatusProgress'>" + sData + "</div>" + sRetake;
	}
	
	// show the question menu
	showQuestionMenu();
	
	// update the state information if needed
	saveCurrentState();
}

/***
* Returns the delayed feedback in a string buffer
***/
function returnDelayedFeedback() {
	// add the delayed feedback message
	var sData = "<div class='delayedFeedbackMsg'>" + XsMsgDelayed + "</div>";
	
	// return the string
	return sData;
}

/***
* Show the question menu
***/
function showQuestionMenu() {
	// insert the title
	var sData = "<div class='QitemTitle'>" + XsQitemTitle + "</div>";
	
	// start the table
	sData += "<table class='QitemTable' cellpadding='0' cellspacing='0'><tr>";
	
	//is this a test-out
	if (!inMain(parent)) {
		//yes it is, is it a pretest
		if(parent._bPretest == true){
			// loop through the sections in the test
			for (var i=0; i<_nObjectives; i++) {
				//loop through the questions in the section.
				for(var j=0; j<test[i].pool.length; j++){
				// see if this is the current question
					if (i == _nSectionCurrent && j == _nQuestionCurrent) {
						// it is, show the pointer
						sData += "<td height='16'><img src='../../Template/Images/kc-arrow.png' width='26' height='14' border='0'></td>";
					} else {
						// it is not, do not show the pointer
						sData += "<td height='16'>&nbsp;</td>";
					}
				}
			}
					// add the end row end and start
			sData += "</tr><tr>";
			var nQTotal = 0;
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				for(var j=0; j<test[i].pool.length; j++){
					nQTotal++;
					// see if this is the current question
					if (i == _nSectionCurrent && j == _nQuestionCurrent) {
						// it is, show the question as current
						sData += "<td class='QitemCurrent'><a href='' onclick='gotoQuestion(" + i + "," + j +");return false'>" + "Q" + nQTotal + "</a></td>";
					} else {
						// it is not, see if the question has a response
						if (test[i].pool[ j ].response != "") {
							// it does, show the question with a response
							sData += "<td class='QitemReponse'><a href='' onclick='gotoQuestion(" + i + "," + j +");return false'>" + "Q" + nQTotal + "</a></td>";
						} else {
							// it does not, show the questions without a response
							sData += "<td class='QitemNoReponse'><a href='' onclick='gotoQuestion(" + i + "," + j +");return false'>" + "Q" + nQTotal + "</a></td>";
						}
					}
				}
			}
			
			// add the end row end and start
			sData += "</tr><tr>";
			
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				for(var j=0; j<test[i].pool.length; j++){
					// it is not, see if the question has a response AND NOT(this is not the current selection AND submit-warning)
					if (test[i].pool[ j ].response != "" && !(i == _nSectionCurrent  && j == _nQuestionCurrent && _bSubmitWarning) ) {
						// it does, see if the learner provided the correct answer
						if (test[i].pool[ j ].response == test[i].pool[ j ].answer) {
							// he did, show the correct icon
							sData += "<td class='QitemCorrect'><a href='' onclick='gotoQuestion(" + i + "," + j +");return false'>" + "<img src='../../Template/Images/kc-correct.png' width='26' height='26' border='0'>" + "</a></td>";
						} else {
							// incorrect answer, show the incorrect icon
							sData += "<td class='QitemIncorrect'><a href='' onclick='gotoQuestion(" + i + "," + j +");return false'>" + "<img src='../../Template/Images/kc-incorrect.png' width='26' height='26' border='0'>" + "</a></td>";
						}
					} else {
						// no response, show no answer
						sData += "<td class='QitemNone'><a href='' onclick='gotoQuestion(" + i + "," + j +");return false'>" + "<img src='../../Template/Images/kc-not-attempted.png' width='26' height='26' border='0'>" + "</a></td>";
					}
				}
			}
				
		}else{
			// loop through the sections in the test
			for (var i=0; i<_nObjectives; i++) {
				// see if this is the current question
				if (i == _nSectionCurrent) {
					// it is, show the pointer
					sData += "<td height='16'><img src='../../Template/Images/kc-arrow.png' width='26' height='14' border='0'></td>";
				} else {
					// it is not, do not show the pointer
					sData += "<td height='16'>&nbsp;</td>";
				}
			}
			// add the end row end and start
			sData += "</tr><tr>";
			
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				// see if this is the current question
				if (i == _nSectionCurrent) {
					// it is, show the question as current
					sData += "<td class='QitemCurrent'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "Q" + (i+1) + "</a></td>";
				} else {
					// it is not, see if the question has a response
					if (test[i].pool[ test[i].selected ].response != "") {
						// it does, show the question with a response
						sData += "<td class='QitemReponse'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "Q" + (i+1) + "</a></td>";
					} else {
						// it does not, show the questions without a response
						sData += "<td class='QitemNoReponse'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "Q" + (i+1) + "</a></td>";
					}
				}
			}
				// add the end row end and start
			sData += "</tr><tr>";

	
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				// it is not, see if the question has a response AND NOT(this is not the current selection AND submit-warning)
				if (test[i].pool[ test[i].selected ].response != "" && !(i == _nSectionCurrent  && _bSubmitWarning) ) {
					// it does, see if the learner provided the correct answer
					if (test[i].pool[ test[i].selected ].response == test[i].pool[ test[i].selected ].answer) {
						// he did, show the correct icon
						sData += "<td class='QitemCorrect'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "<img src='../../Template/Images/kc-correct.png' width='26' height='26' border='0'>" + "</a></td>";
					} else {
						// incorrect answer, show the incorrect icon
						sData += "<td class='QitemIncorrect'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "<img src='../../Template/Images/kc-incorrect.png' width='26' height='26' border='0'>" + "</a></td>";
					}
				} else {
					// no response, show no answer
					sData += "<td class='QitemNone'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "<img src='../../Template/Images/kc-not-attempted.png' width='26' height='26' border='0'>" + "</a></td>";
				}
			}
		}
	}else{
		// see if we are in the post test
		if(parent._bPosttest){
			// we are, loop through the sections in the test
			for (var i=0; i<_nObjectives; i++) {
				// if there was a pre test, see if we are tested out
				if(parent._bPretest && parent._bTestOut && test[i].testedOut == '1' && !parent._sPT_RequirePassedObjectives)
					continue;
				
				// not tested out, so include this section
				for(var j=0; j < test[i].pool.length; j++){
					// see if this is the current question
					if (i == _nSectionCurrent && j == _nQuestionCurrent) {
						// it is, show the pointer
						sData += "<td height='16'><img src='../../Template/Images/kc-arrow.png' width='26' height='14' border='0'></td>";
					} else {
						// it is not, do not show the pointer
						sData += "<td height='16'>&nbsp;</td>";
					}
				}
			}
			// add the end row end and start
			sData += "</tr><tr>";
			
			// counter variable to accurately disregard tested out questions
			var nNTOCount = 0;
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				// if there was a pre test, see if we are tested out
				if(parent._bPretest && parent._bTestOut && test[i].testedOut == '1' && !parent._sPT_RequirePassedObjectives)
					continue;
				
				for(var j=0; j < test[_aOrder[i]].pool.length; j++){
					// increment the non tested out counter
					nNTOCount++;
					// see if this is the current question
					if (_aOrder[i] == _nSectionCurrent && j == _nQuestionCurrent) {
						// it is, show the question as current
						sData += "<td class='QitemCurrent'><a href='' onclick='gotoQuestion(" + _aOrder[i] + "," + j + ");return false'>" + "Q" + (nNTOCount) + "</a></td>";
					} else {
						// it is not, see if the question has a response
						if (test[_aOrder[i]].pool[j].response != "") {
							// it does, show the question with a response
							sData += "<td class='QitemReponse'><a href='' onclick='gotoQuestion(" + _aOrder[i] + "," + j + ");return false'>" + "Q" + (nNTOCount) + "</a></td>";
						} else {
							// it does not, show the questions without a response
							sData += "<td class='QitemNoReponse'><a href='' onclick='gotoQuestion(" + _aOrder[i] + "," + j + ");return false'>" + "Q" + (nNTOCount) + "</a></td>";
						}
					}
				}
			}
			
			// add the end row end and start
			sData += "</tr><tr>";
		
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				// if there was a pre test, see if we are tested out
				if(parent._bPretest && parent._bTestOut && test[i].testedOut == '1' && !parent._sPT_RequirePassedObjectives)
					continue;
				
				for(var j=0; j < test[i].pool.length; j++){	
					// it is not, see if the question has a response AND NOT(this is not the current selection AND submit-warning)
					if (test[i].pool[j].response != "" && !(i == _nSectionCurrent && j == _nQuestionCurrent && _bSubmitWarning) ) {
						// it does, see if the learner provided the correct answer
						if (test[i].pool[j].response == test[i].pool[j].answer) {
							// he did, show the correct icon
							sData += "<td class='QitemCorrect'><a href='' onclick='gotoQuestion(" + i + "," + j +");return false'>" + "<img src='../../Template/Images/kc-correct.png' width='26' height='26' border='0'>" + "</a></td>";
						} else {
							// incorrect answer, show the incorrect icon
							sData += "<td class='QitemIncorrect'><a href='' onclick='gotoQuestion(" + i + "," + j + ");return false'>" + "<img src='../../Template/Images/kc-incorrect.png' width='26' height='26' border='0'>" + "</a></td>";
						}
					} else {
						// no response, show no answer
						sData += "<td class='QitemNone'><a href='' onclick='gotoQuestion(" + i + "," + j + ");return false'>" + "<img src='../../Template/Images/kc-not-attempted.png' width='26' height='26' border='0'>" + "</a></td>";
					}
				}
			}		
		}else{
			// loop through the sections in the test
			for (var i=0; i<_nObjectives; i++) {
				// if there was a pre test, see if we are tested out
				if(parent._bPretest && parent._bTestOut && test[_aOrder[i]].testedOut == '1')
					continue;
				// see if this is the current question
				if (i == _nSectionCurrent) {
					// it is, show the pointer
					sData += "<td height='16'><img src='../../Template/Images/kc-arrow.png' width='26' height='14' border='0'></td>";
				} else {
					// it is not, do not show the pointer
					sData += "<td height='16'>&nbsp;</td>";
				}
			}
			// add the end row end and start
			sData += "</tr><tr>";
			
			// counter variable to accurately disregard tested out questions
			var nNTOCount = 0;
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				// if there was a pre test, see if we are tested out
				if(parent._bPretest && parent._bTestOut && test[_aOrder[i]].testedOut == '1')
					continue;
				
				// increment the non tested out counter
				nNTOCount++;
				// see if this is the current question
				if (i == _nSectionCurrent) {
					// it is, show the question as current
					sData += "<td class='QitemCurrent'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "Q" + (nNTOCount) + "</a></td>";
				} else {
					// it is not, see if the question has a response
					if (test[i].pool[ test[i].selected ].response != "") {
						// it does, show the question with a response
						sData += "<td class='QitemReponse'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "Q" + (nNTOCount) + "</a></td>";
					} else {
						// it does not, show the questions without a response
						sData += "<td class='QitemNoReponse'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "Q" + (nNTOCount) + "</a></td>";
					}
				}
			}
			
			// add the end row end and start
			sData += "</tr><tr>";
			
			// loop through the sections in the test
			for (i=0; i<_nObjectives; i++) {
				// if there was a pre test, see if we are tested out
				if(parent._bPretest && parent._bTestOut && test[_aOrder[i]].testedOut == '1')
					continue;
					
				// it is not, see if the question has a response AND NOT(this is not the current selection AND submit-warning)
				if (test[i].pool[ test[i].selected ].response != "" && !(i == _nSectionCurrent  && _bSubmitWarning) ) {
					// it does, see if the learner provided the correct answer
					if (test[i].pool[ test[i].selected ].response == test[i].pool[ test[i].selected ].answer) {
						// he did, show the correct icon
						sData += "<td class='QitemCorrect'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "<img src='../../Template/Images/kc-correct.png' width='26' height='26' border='0'>" + "</a></td>";
					} else {
						// incorrect answer, show the incorrect icon
						sData += "<td class='QitemIncorrect'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "<img src='../../Template/Images/kc-incorrect.png' width='26' height='26' border='0'>" + "</a></td>";
					}
				} else {
					// no response, show no answer
					sData += "<td class='QitemNone'><a href='' onclick='gotoQuestion(" + i + ",0);return false'>" + "<img src='../../Template/Images/kc-not-attempted.png' width='26' height='26' border='0'>" + "</a></td>";
				}
			}
	  	}			
	}
			
	// add the end of the row and end of table
	sData += "</tr></table>";
	
	// show the table in the div
	document.getElementById("questionList").innerHTML = sData;
}

/***
* navigate to the review page
***/
function reviewPage(sPage) {
	// see if the tellnav function exists
	if (parent.LoadContent) {
		// it does, split the page into an array
		var aParts = sPage.split('.');
		
		// navigate to the correct module, section and subsection
		parent.LoadContent(aParts.join('_'));
	}
}


/***
* add HTML for the nav buttons
***/
function navButtons() {
	// var used to show the prev and next buttons
	var sShowPrev = "";
	var sShowNext = "";
	var sPrev = XsNavPrev;
	var sNext = XsNavNext;
	
	if (!inMain(parent)) {
		if(parent._bPretest == true){
			
			// see what type of page we have
			if (_nSectionCurrent == -1 && _nQuestionCurrent == -1) {
				// introduction page, do not show the prev button
				sShowPrev = "display:none";
				
				// show the first question link
				sNext = XsNavFirst;
			} else if (_bShowIntro && _nSectionCurrent == 0 && _nQuestionCurrent == 0){
				// we have an intro page and this is the first question, show the introduction link
				sPrev = XsNavIntro;
				
				// hide the next button if we have a single quesiton text
			//	if (_nObjectives == 1) sShowNext = "visibility:hidden";
			
			} else if (!_bShowIntro && _nSectionCurrent == 0 && _nQuestionCurrent == 0) {
				// we DO NOT have an intro page AND this is the first question, do not show the back button
				sShowPrev = "visibility:hidden";
				
				// hide the next button if we have a single quesiton text
				//if (_nObjectives == 1) sShowNext = "visibility:hidden";
			
			} else if (_nSectionCurrent == _nObjectives-1 && _nQuestionCurrent == Number(test[_nSectionCurrent].pool.length -1) && !_bShowResultsPage) {
				// this is the last page AND we DO NOT have a results page, do not show the next button
				sShowNext = "visibility:hidden";
			
			} else if (_nSectionCurrent == _nObjectives-1 && _nQuestionCurrent == Number(test[_nSectionCurrent].pool.length -1) && _bShowResultsPage) {
				// this is the last page AND we have a results page, do not show the next button
				sNext = XsNavResults;
			
			} else if (_bShowResultsPage && _nSectionCurrent == _nObjectives) {
				// we have a results page and this is the results page
				sShowNext = "visibility:hidden";
			}		
		}else{
			
			// see what type of page we have
			if (_nSectionCurrent == -1) {
				// introduction page, do not show the prev button
				sShowPrev = "display:none";
				
				// show the first question link
				sNext = XsNavFirst;
			} else if (_bShowIntro && _nSectionCurrent == 0){
				// we have an intro page and this is the first question, show the introduction link
				sPrev = XsNavIntro;
				
				// hide the next button if we have a single quesiton text
				if (_nObjectives == 1) sShowNext = "visibility:hidden";
			} else if (!_bShowIntro && _nSectionCurrent == 0) {
				// we DO NOT have an intro page AND this is the first question, do not show the back button
				sShowPrev = "visibility:hidden";
				
				// hide the next button if we have a single quesiton text
				if (_nObjectives == 1) sShowNext = "visibility:hidden";
			} else if (_nSectionCurrent == _nObjectives-1 && !_bShowResultsPage) {
				// this is the last page AND we DO NOT have a results page, do not show the next button
				sShowNext = "visibility:hidden";
			} else if (_nSectionCurrent == _nObjectives-1 && _bShowResultsPage) {
				// this is the last page AND we have a results page, do not show the next button
				sNext = XsNavResults;
			} else if (_bShowResultsPage && _nSectionCurrent == _nObjectives) {
				// we have a results page and this is the results page
				sShowNext = "visibility:hidden";
			}
		}
	}else{
		
		if(parent._bPosttest){
			// initialize the adjusted question number index for tested out questions. this takes the place of _nSectionCurrent
			var nNTOSectionCurrent = _nSectionCurrent;
			
			// initializ the adjusted total of non tested out questions. this takes the place of _nObjectives.
			var nNTOTotalQuestions = _nObjectives;
			
			var nNTOLastObjective = getLastNonTestedOutObjective();
			
			// set the index of non tested out questions
			nNTOSectionCurrent = (getNonTestedOutQuestionNumber()-1);
			
			// set the total of non testd out questions
			nNTOTotalQuestions = getNonTestedOutQuestionTotal();
		
			// see what type of page we have
			if (_nSectionCurrent == -1 && _nQuestionCurrent == -1) {
				// introduction page, do not show the prev button
				sShowPrev = "display:none";
				
				// get the index of this Post Test
				var nPosttest = parent._nModTotal-1;
				var bModsIncomplete = false;
				// see if user must complete all required modules and if this post test was answered before
				if (parent._bPT_MustCompleteModulesFirst) {
					// not answered, so we need to verify that all required mods have been completed
					
					// loop through the knowledge check array
					for (var i=0; i < nPosttest; i++) {
						// see if this knowledge check is passed AND the module is required
						if (parent._aKcState[i].substring(0,1) != "P" && parent._aModRequired[i]) {
							bModsIncomplete = true;
							break;
						}
					}
				}
				
				// See if there are still modules that need to be completed
				if(bModsIncomplete)
					sShowNext = "visibility:hidden";
					
				// see if this post test has been tested out
				if(parent._aNodeStatus[_nID].sTestedOut == "1")
				// post test tested out, so we do NOT want to show the next button.
					sShowNext = "visibility:hidden";
					
				// see if any questions have NOT been tested out
				if(nNTOTotalQuestions == 0)
					// all questions tested out, so we do NOT want to show the next button.
					sShowNext = "visibility:hidden";
					
				// If the user is out of attempts, then hide the next button too
				if(parent._sPT_MaxAttempts > 0 && _nPosttestAttempts >= parent._sPT_MaxAttempts)
					sShowNext = "visibility:hidden";
					
				// show the first question link
				sNext = XsNavFirst;
			} else if (_bShowIntro && nNTOSectionCurrent  == 0 && _nQuestionCurrent == 0){
				// we have an intro page and this is the first question, show the introduction link
				sPrev = XsNavIntro;
				
				// hide the next button if we have a single quesiton text
			//	if (_nObjectives == 1) sShowNext = "visibility:hidden";
			
			} else if (!_bShowIntro && nNTOSectionCurrent  == 0 && _nQuestionCurrent == 0) {
				// we DO NOT have an intro page AND this is the first question, do not show the back button
				sShowPrev = "visibility:hidden";
				
				// hide the next button if we have a single quesiton text
				//if (_nObjectives == 1) sShowNext = "visibility:hidden";
			
			}
			
			if (_nSectionCurrent == nNTOLastObjective && _nQuestionCurrent == Number(test[_nSectionCurrent].pool.length -1) && !_bShowResultsPage) {
				// this is the last page AND we DO NOT have a results page, do not show the next button
				sShowNext = "visibility:hidden";
			
			} else if (_nSectionCurrent == nNTOLastObjective && _nQuestionCurrent == Number(test[_nSectionCurrent].pool.length -1) && _bShowResultsPage) {
				// this is the last page AND we have a results page, do not show the next button
				sNext = XsNavResults;
			
			} else if (_bShowResultsPage && _nSectionCurrent > nNTOLastObjective) {
				// we have a results page and this is the results page
				sShowNext = "visibility:hidden";
			}		
		}else{
			// initialize the adjusted question number index for tested out questions. this takes the place of _nSectionCurrent
			var nNTOQuestionIndex = _nSectionCurrent;
			
			// initializ the adjusted total of non tested out questions. this takes the place of _nObjectives.
			var nNTOTotalQuestions = _nObjectives;
			
			// set the index of non tested out questions
			nNTOQuestionIndex = (getNonTestedOutQuestionNumber()-1);
			
			// set the total of non testd out questions
			nNTOTotalQuestions = getNonTestedOutQuestionTotal();
			
			// see what type of page we have
			if (_nSectionCurrent == -1) {
				// introduction page, do not show the prev button
				sShowPrev = "display:none";
				
				// show the first question link
				sNext = XsNavFirst;
				
				// see if any questions have NOT been tested out
				if(nNTOTotalQuestions == 0)
					// all questions tested out, so we do NOT want to show the next button.
					sShowNext = "visibility:hidden";
			} else if (_bShowIntro && (nNTOQuestionIndex == 0)){
				// we have an intro page and this is the first question, show the introduction link
				sPrev = XsNavIntro;
				
				// hide the next button if we have a single quesiton test
			if (nNTOTotalQuestions == 1) sShowNext = "visibility:hidden";
			} else if (!_bShowIntro && nNTOQuestionIndex == 0) {
				// we DO NOT have an intro page AND this is the first question, do not show the back button
				sShowPrev = "visibility:hidden";
				
				// hide the next button if we have a single quesiton text
			if (nNTOTotalQuestions == 1) sShowNext = "visibility:hidden";
			} else if (nNTOQuestionIndex == (nNTOTotalQuestions-1) && !_bShowResultsPage) {
				// this is the last page AND we DO NOT have a results page, do not show the next button
				sShowNext = "visibility:hidden";
			} else if (nNTOQuestionIndex == (nNTOTotalQuestions-1) && _bShowResultsPage) {
				// this is the last page AND we have a results page, do not show the next button
				sNext = XsNavResults;
			} else if (_bShowResultsPage && nNTOQuestionIndex == nNTOTotalQuestions) {
				// we have a results page and this is the results page
				sShowNext = "visibility:hidden";
			}	
		}
	}	
	// create a div to hold the nav buttons
	var s = "<div class='navigation'>";
	
	// add the previous button
	s += '<input type="button" class="assessButton" onclick="PrevPage();return false;" style="' + sShowPrev + '" value="' + sPrev + '" />';

	// add a spacer
	s += "  ";
	
	// add the next button
	s += '<input type="button" class="assessButton" onclick="NextPage();return false;" style="' + sShowNext + '" value="' + sNext + '" />';
	
	// add the end of div
	s += "</div>";

	return s;
}

/***
* Enable the submit button
***/
function enableSubmit(ctl) {
	ctl.form.evalButton.disabled = false;
}

/***
* return the review information to a question
***/
function addReview() {
	// show the review information
	var feedback = "<tr><td><div class='backLink'>" + XsReviewPreText + " ";
	// see if we want to show backlinks
	if (_bShowBackLinks) {
		// we do, show the review text
		feedback += "<a href='' onclick='reviewPage(\"" + _oQuestion.reviewLink + "\");return false;'>";
		feedback += _oQuestion.reviewText;
		feedback += "</a>";
	} else {
		// just show the text
		feedback += _oQuestion.reviewText;
	}
	feedback += "</div></td></tr>";
	
	return feedback;
}

function addRetry() {
	var feedback = "";
	
	// see if retry is allowed
	if (_bAllowRetry) {
		// it is, link for another question
		feedback += "<tr><td class='anotherQuestion'>" + XsAnotherQuestion + " ";
		feedback += "<input type='button' class='assessButton' onclick='anotherQuestion();return false;' value='" + XsAnotherQuestionLink + "' /></td></tr>";
	}
	
	return feedback;
}

/***
* Show a true-false question
***/
function showTrueFalse() {
	/* strings used to set the feedback and the check status of the radio buttons */
	var feedback;
	var checkedTrue = "";
	var checkedFalse = "";

	// see if the learner has already provided a response
	if (_oQuestion.response != "") {
		/* there is an answer, set the appropriate checked value */
		if (_oQuestion.response == "t")
			checkedTrue = "checked";
		else
			checkedFalse = "checked";
			
		// see if we are showing the submit warning
		if (_bSubmitWarning) {
			// we are, add the div
			var feedback = '<div class="submitWarning">';
		
			// add the instructions
			feedback += "<div class='submitMessage'>" + XsSubmitMessage + "</div>";
		
			// add the question
			feedback += "<div class='submitQuestion'>" + XsSubmitQuestion + "</div>";
			
			// add the check answer button
			feedback += "<div>";		
			feedback += '<input type="button" name="evalButton" class="assessButton" onclick="evalTrueFalse(true);return false;" value="' + XsMsgCheck + '" />';
			feedback += "</div>";
		
			// end of feedback section
			feedback += navButtons() + '</div>';
		} else {
			// submit was clicked, init the feedback string
			feedback = '<div class="feedback" id="feedback">';
			
			// create the start of the table to show the feedback
			feedback += '<table cellspacing="0" cellpadding="0"><tr><td valign="top" class="feedbackCheck">';
	
			/* see if the answer was correct */
			if (_oQuestion.response == _oQuestion.answer) {
				// it was, show the check
				feedback += '<img src="../../Template/Images/kc-feedback-correct.png" align="left"></td>';
				feedback += '<td><table cellspacing="0" cellpadding="0">';
				feedback += '<tr><td><div class="feedbackCorrect">' + XsFeedbackCorrect + '</div></td></tr>';
				feedback += '<tr><td><div class="feedbackText">' + _oQuestion.feedbackCorrect + '</div></td></tr>';
			} else {
				// build the correct answer string
				var sTF = _oQuestion.answer == 't' ? XsMsgTrue : XsMsgFalse;
				var sCorrectIs = " " + XsCorrectIs + " " + sTF + ".";
				
				// wrong answer, show the check
				feedback += '<img src="../../Template/Images/kc-feedback-incorrect.png" align="left"></td>';
				feedback += '<td><table cellspacing="0" cellpadding="0">';
				feedback += '<tr><td><div class="feedbackIncorrect">' + XsFeedbackIncorrect + sCorrectIs + '</div></td></tr>';
				feedback += '<tr><td><div class="feedbackText">' + _oQuestion.feedbackIncorrect + '</div></td></tr>';
				
				// add retry link
				feedback += addRetry();
			}
			
			// show the review information
			feedback += addReview();
			
			// end the tables
			feedback += '</table></td></tr></table>';
			
			// end of feedback section
			feedback += "<div class='navContainer'>" + navButtons() + "</div>" + '</div>';
		}
	} else {
		// no response, init the nav button box
		feedback = '<div class="navBox">';
		
		// add the instructions
		feedback += "<div class='navInstructions'>" + XsMsgDirectionsTF + "</div>";
	
		// add the check answer button
		feedback += "<div>";		
		feedback += '<input type="button" name="evalButton" disabled class="assessButton" onclick="evalTrueFalse(true);return false;" value="' + XsMsgCheck + '" />';
		feedback += "</div>";
	
		// end of feedback section
		feedback += navButtons() + '</div>';
	}

	/* see if the learner has already hit the maximum number of tries */
	var bTooMany = (_oQuestion.attempts >= numberAttempts) ? true : false;
	if (bTooMany)
		var sData = XsMsgTooMany;
	else
		var sData = "";

	/* see if the learner has reached the time out */
	if ( _bTimeLimitReached)
		sData += XsMsgTimeout;

	/* make sure we will disable the question for too many attempts or a timeout */
	bTooMany = bTooMany || _bTimeLimitReached;
	
	/* put together the question */
	sData += '<div class="levelOne">' + getPageNumber() + '</div>';
	sData += "<div class='questionPrompt'>";
	sData +=  _oQuestion.question + "</div>";
	sData += '<FORM name=qform>';
	sData += '<INPUT onclick="enableSubmit(this)" id="choicet" type=radio';
	if (bTooMany)
		sData += ' disabled';
	sData += ' value=true name=answer ' + checkedTrue + '><LABEL for="choicet">' + XsMsgTrue + '</LABEL><BR />';
	sData += ' <INPUT onclick="enableSubmit(this)" id="choicef" type=radio';
	if (bTooMany)
		sData += ' disabled';
	sData += ' value=false name=answer ' + checkedFalse + '><LABEL for="choicef">' + XsMsgFalse + '</LABEL><br /><br />';
	
	// show the feedback
	sData += feedback;
	
	// add the end of form
	sData += '</FORM>';

	/* show it */
	document.getElementById("question").innerHTML = sData;
	
	// show the sumary information
	showSummary();
}

/***
* Show a muliple choice question
***/
function showChoice() {
	var i;
	var sAlpha = new Array("A","B","C","D","E","F");
	
	/* strings used to set the feedback and the check status of the radio buttons */
	var feedback;
	
	/* see if the learner has already provided a response */
	if (_oQuestion.response != "") {
		// he did, see if we need to show the submit warning
		if (_bSubmitWarning) {
			// we do
			var feedback = '<div class="submitWarning">';
		
			// add the instructions
			feedback += "<div class='submitMessage'>" + XsSubmitMessage + "</div>";
		
			// add the question
			feedback += "<div class='submitQuestion'>" + XsSubmitQuestion + "</div>";
			
			// add the check answer button
			feedback += "<div>";		
			feedback += '<input type="button" name="evalButton" class="assessButton" onclick="evalChoice(true);return false;" value="' + XsMsgCheck + '" />';
			feedback += "</div>";
		
			// end of feedback section
			feedback += navButtons() + '</div>';		
		} else {
			// submit was clicked, init the feedback string
			feedback = '<div class="feedback" id="feedback">';
			
			// create the start of the table to show the feedback
			feedback += '<table cellspacing="0" cellpadding="0"><tr><td valign="top" class="feedbackCheck">';
	
			/* see if the answer was correct */
			if (_oQuestion.response == _oQuestion.answer) {
				// it was, show the check
				feedback += '<img src="../../Template/Images/kc-feedback-correct.png" align="left"></td>';
				feedback += '<td><table cellspacing="0" cellpadding="0">';
				feedback += '<tr><td><div class="feedbackCorrect">' + XsFeedbackCorrect + '</div></td></tr>';
				feedback += '<tr><td><div class="feedbackText">' + _oQuestion.feedback[_oQuestion.response-1] + '</div></td></tr>';
			} else {
				// build the correct answer string
				var sCorrectIs = " " + XsCorrectIs + " " + sAlpha[ (_oQuestion.answer-1) ] + ".";
				
				// wrong answer, show the check
				feedback += '<img src="../../Template/Images/kc-feedback-incorrect.png" align="left"></td>';
				feedback += '<td><table cellspacing="0" cellpadding="0">';
				feedback += '<tr><td><div class="feedbackIncorrect">' + XsFeedbackIncorrect + sCorrectIs + '</div></td></tr>';
				feedback += '<tr><td><div class="feedbackText">' + _oQuestion.feedback[_oQuestion.response-1] + '</div></td></tr>';
				
				// add retry link
				feedback += addRetry();
			}
			
			// show the review information
			feedback += addReview();
			
			// end the tables
			feedback += '</table></td></tr></table>';
			
			// end of feedback section
			feedback += "<div class='navContainer'>" + navButtons() + "</div>" + '</div>';
		}
	} else {
		// no response, init the nav box
		feedback = '<div class="navBox">';
		
		// add the instructions
		feedback += "<div class='navInstructions'>" + XsMsgDirectionsMC + "</div>";
	
		// add the check answer button
		feedback += "<div>";		
		feedback += '<input type="button" name="evalButton" disabled class="assessButton" onclick="evalChoice(true);return false;" value="' + XsMsgCheck + '" />';
		feedback += "</div>";
	
		// end of feedback section
		feedback += navButtons() + '</div>';
	}

	/* get the number of choices */
	var numChoices = _oQuestion.choice.length;

	/* see if we have created the choices sequence for this question */
	if (_oQuestion.choiceRand == null) {
		/* we have not, create the array */
		_oQuestion.choiceRand = new Array();
		for (i=0; i<numChoices; i++)
			_oQuestion.choiceRand[i] = i + 1;

		/* see if we need to randomize the choices */
		if (randomizeChoices == true) {
			/* we do, randomize them */
			for (i=0; i<numChoices; i++) {
				var rand = Math.floor(Math.random()* numChoices);
				var temp = _oQuestion.choiceRand[i];
				_oQuestion.choiceRand[i] = _oQuestion.choiceRand[rand];
				_oQuestion.choiceRand[rand] = temp;
			}
		}
	}

	/* see if the learner has already hit the maximum number of tries */
	var bTooMany = (_oQuestion.attempts >= numberAttempts) ? true : false;
	if (bTooMany)
		var sData = XsMsgTooMany;
	else
		var sData = "";

	/* see if the learner has reached the time out */
	if ( _bTimeLimitReached)
		sData += XsMsgTimeout;

	/* make sure we will disable the question for too many attempts or a timeout */
	bTooMany = bTooMany || _bTimeLimitReached;
	
	/* put together the question and the instructions */
	sData += '<div class="levelOne">' + getPageNumber() + '</div>';
	sData += "<div class='questionPrompt'>";
	sData += _oQuestion.question + "</div>";
	sData += '<FORM name=qform><div>';
	sData += '<table class="Choices">';

	/* add the choices */
	for (i=0; i<numChoices; i++) {
		/* use the random array to decide which choice to display */
		nChoice = _oQuestion.choiceRand[i];

		/* start building the choice string */
		sData += '<tr><td class="ChoicesRadio"><INPUT onclick="enableSubmit(this)" type=radio value=';
		sData += nChoice;
		sData += ' name=answer';

		if (bTooMany)
			sData += ' disabled';

		/* see if this was the response from last time, if so, mark it as checked */
		if (nChoice == _oQuestion.response)
			sData += ' checked>';
		else
			sData += ' id="cc' + i + '"></td>';

		/* get the text for this choice */
		sData += '<td class="ChoicesAlpha">' + sAlpha[i] + '.</td><td class="ChoicesText"><label for="cc' + i + '">' + _oQuestion.choice[i] + '</label></td>';
		sData += '</tr>';
	}
	
	sData += '</table>';
	
	// show the feedback
	sData += '</div><BR />' + feedback;
	
	// add the end of form
	sData += '</FORM>';

	/* show it */
	document.getElementById("question").innerHTML = sData;
	
	// show the summary information
	showSummary();
}

/***
* Show a muliple choice with multiple correct question
***/
function showChoiceMultiple() {
	var i;
	var sAlpha = new Array("A","B","C","D","E","F", "G");
	
	/* strings used to set the feedback and the check status of the radio buttons */
	var feedback = "";
	
	/* see if the learner has already provided a response */
	if (_oQuestion.response != "") {
		// he did, see if we need to show the submit warning
		if (_bSubmitWarning) {
			// we do
			var feedback = '<div class="submitWarning">';
		
			// add the instructions
			feedback += "<div class='submitMessage'>" + XsSubmitMessage + "</div>";
		
			// add the question
			feedback += "<div class='submitQuestion'>" + XsSubmitQuestion + "</div>";
			
			// add the check answer button
			feedback += "<div>";		
			feedback += '<input name="evalButton" type="button" class="assessButton" onclick="evalChoiceMultiple(true);return false;" value="' + XsMsgCheck + '" />';
			feedback += "</div>";
		
			// end of feedback section
			feedback += navButtons() + '</div>';		
		} else {
			// submit was clicked, init the feedback string
			feedback = '<div class="feedback" id="feedback">';
			
			// create the start of the table to show the feedback
			feedback += '<table cellspacing="0" cellpadding="0"><tr><td valign="top" class="feedbackCheck">';
	
			/* see if the answer was correct */
			if (_oQuestion.response == _oQuestion.answer) {
				// it was, show the check
				feedback += '<img src="../../Template/Images/kc-feedback-correct.png" align="left"></td>';
				feedback += '<td><table cellspacing="0" cellpadding="0">';
				feedback += '<tr><td><div class="feedbackCorrect">' + XsFeedbackCorrect + '</div></td></tr>';
				feedback += '<tr><td><div class="feedbackText">' + _oQuestion.feedbackCorrect + '</div></td></tr>';

			} else {
				// build the correct answer string
				var sCorrectIs = " ";
				var aAnswers = _oQuestion.answer.split(',');
				for (i=0; i<aAnswers.length; i++) {
					if (sCorrectIs == " ") {
						sCorrectIs += sAlpha[aAnswers[i]-1];
					} else {
						sCorrectIs += ", " + sAlpha[aAnswers[i]-1];
					}
				}
				sCorrectIs = " " + XsCorrectIs + " " + sCorrectIs;
				
				// wrong answer, show the check
				feedback += '<img src="../../Template/Images/kc-feedback-incorrect.png" align="left"></td>';
				feedback += '<td><table cellspacing="0" cellpadding="0">';
				feedback += '<tr><td><div class="feedbackIncorrect">' + XsFeedbackIncorrect + sCorrectIs + '</div></td></tr>';
				feedback += '<tr><td><div class="feedbackText">' + _oQuestion.feedbackIncorrect + '</div></td></tr>';
				
				// add retry link
				feedback += addRetry();
			}
			
			// show the review information
			feedback += addReview();
			
			// end the tables
			feedback += '</table></td></tr></table>';
			
			// end of feedback section
			feedback += "<div class='navContainer'>" + navButtons() + "</div>" + '</div>';
		}
	} else {
		// no response, init the nav box
		feedback = '<div class="navBox">';
		
		// add the instructions
		feedback += "<div class='navInstructions'>" + XsMsgDirectionsMCM + "</div>";
	
		// add the check answer button
		feedback += "<div>";		
		feedback += '<input type="button" name="evalButton" disabled class="assessButton" onclick="evalChoiceMultiple(true);return false;" value="' + XsMsgCheck + '" />';
		feedback += "</div>";
	
		// end of feedback section
		feedback += navButtons() + '</div>';
	}

	/* get the number of choices */
	var numChoices = _oQuestion.choice.length;

	/* see if we have created the choices sequence for this question */
	if (_oQuestion.choiceRand == null) {
		/* we have not, create the array */
		_oQuestion.choiceRand = new Array();
		for (i=0; i<numChoices; i++)
			_oQuestion.choiceRand[i] = i + 1;

		/* see if we need to randomize the choices */
		if (randomizeChoices == true) {
			/* we do, randomize them */
			for (i=0; i<numChoices; i++) {
				var rand = Math.floor(Math.random()* numChoices);
				var temp = _oQuestion.choiceRand[i];
				_oQuestion.choiceRand[i] = _oQuestion.choiceRand[rand];
				_oQuestion.choiceRand[rand] = temp;
			}
		}
	}

	/* see if the learner has already hit the maximum number of tries */
	var bTooMany = (_oQuestion.attempts >= numberAttempts) ? true : false;
	if (bTooMany)
		var sData = XsMsgTooMany;
	else
		var sData = "";

	/* see if the learner has reached the time out */
	if (_bTimeLimitReached)
		sData += XsMsgTimeout;

	/* make sure we will disable the question for too many attempts or a timeout */
	bTooMany = bTooMany || _bTimeLimitReached;

	/* put together the question and the instructions */
	sData += '<div class="levelOne">' + getPageNumber() + '</div>';
	sData += "<div class='questionPrompt'>";
	sData += _oQuestion.question + "</div>";
	sData += '<FORM name=qform>';
	sData += '<table class="Choices">';

	/* break the previous answers into a local array */
	var aResponse = _oQuestion.response.split(',');

	/* add the choices */
	for (i=0; i<numChoices; i++) {
		/* use the random array to decide which choice to display */
		nChoice = _oQuestion.choiceRand[i];

		/* start building the choice string */
		sData += '<tr><td class="ChoicesCheck"><INPUT type="checkbox" onclick="enableSubmit(this)" value=';
		sData += nChoice;
		sData += ' name=answer';

		if (bTooMany)
			sData += ' disabled';

		/* see if there were any previous responses */
		if (_oQuestion.response != "") {
			/* there are, look through these responses */
			for (var j=0; j<aResponse.length; j++) {
				if (nChoice == aResponse[j]) {
					sData += ' checked';
					break;
				}
			}
		}

		// add the end of the input tag
		sData += ' id="cc' + i + '"></td>';

		/* get the text for this choice */
		sData += '<td class="ChoicesAlpha">' + sAlpha[i] + '.</td><td class="ChoicesText"><label for="cc' + i + '">' + _oQuestion.choice[i] + '</label></td>';
		sData += '</tr>';
	}
	
	// add the end of the table
	sData += '</table>';
	
	// show the feedback
	sData += '</div><BR />' + feedback;
	
	// add the end of form
	sData += '</FORM>';

	/* show it */
	document.getElementById("question").innerHTML = sData;
	
	// show the summary information
	showSummary();
}

/***
* Show a fill-in question
***/
function showFillIn() {
	var aResponse, sEdit1, sEdit2, sQuestion;
	
	/* strings used to set the feedback and the check status of the radio buttons */
	var feedback = "";

	/* see if the learner has already provided a response */
	if (_oQuestion.response != "") {
		/* there is a response, see if this is the correct answer */
		if (_oQuestion.response == _oQuestion.answer) {
			/* it was, set the correct feedback */
			feedback = _oQuestion.feedbackCorrect;
		} else {
			/* wrong answer, set the incorrect feedback */
			feedback = _oQuestion.feedbackIncorrect;
		}
	}

	/* see if the learner has already hit the maximum number of tries */
	var bTooMany = (_oQuestion.attempts >= numberAttempts) ? true : false;
	if (bTooMany)
		var sData = XsMsgTooMany;
	else
		var sData = "";

	/* see if the learner has reached the time out */
	if ( _bTimeLimitReached)
		sData += XsMsgTimeout;

	/* make sure we will disable the question for too many attempts or a timeout */
	bTooMany = bTooMany || _bTimeLimitReached;
	
	/* see if there were any responses */
	if (_oQuestion.response != "") {
		/* there were, build the first response string */
		aResponse = _oQuestion.response.split(',');
		sEdit1 = 'type="text" name="answer1" value="' + aResponse[0] + '">';

		/* see if there is a second */
		if (aResponse.length > 1) {
			sEdit2 = 'type="text" name="answer2" value="' + aResponse[1] + '">';
		} else {
			sEdit2 = 'type="text" name="answer2" value="">';
		}
	} else {
		/* no answers, use default strings */
		sEdit1 = 'type="text" name="answer1" value="">';
		sEdit2 = 'type="text" name="answer2" value="">';
	}

	/* see if we need to disable the edit controls */
	if (bTooMany) {
		sEdit1 = '<INPUT disabled ' + sEdit1;
		sEdit2 = '<INPUT disabled ' + sEdit2;
	} else {
		sEdit1 = '<INPUT ' + sEdit1;
		sEdit2 = '<INPUT ' + sEdit2;
	}
 
	/* insert the edit field into the placeholder */
	sQuestion = getPageNumber() + _oQuestion.question;
	sQuestion = sQuestion.replace(/%%1/g,sEdit1);
	sQuestion = sQuestion.replace(/%%2/g,sEdit2);

	/* put together the question */
	var aAnswer = _oQuestion.answer.split(',');
	if (aAnswer.length == 1)
		sData += XsMsgDirectionsFI;
	else
		sData += XsMsgDirectionsFIM;
	sData += '<FORM name=qform onSubmit="return false">';
	sData += sQuestion;
	sData += '<br /><br />'
	// decide if we need to show immediate feedback
	if (immediateFeedback) {
		// we do, show the check answer button
		sData += '<INPUT class=check_button type=button value="' + XsMsgCheck + '" name=check';
		if (bTooMany)
			sData += ' disabled';
		sData += ' onclick=evalFillIn(true)>';
	}
	sData += '</FORM><br />';
	
	// decide if we need to show immediate feedback
	if (immediateFeedback) {
		// we do
		sData += '<SPAN class=feedback id=feedback>' + feedback + '</SPAN>';
	}

	/* show it */
	document.getElementById("question").innerHTML = sData;

	/* set focus */
	if (!bTooMany) {
		tf = document.getElementsByName("answer1")[0];
		tf.focus();
		tf.focus();
	}
}

/***
* Show a matching question
***/
function showMatching() {
	var i, aResponse;
	
	// see if the answer is in the questions.js format
	if (_oQuestion.answer.indexOf("-") != -1) {
		// it is, conver to scorm 2004 format for comparisons with the response
		_oQuestion.answer = answerTo2004(_oQuestion.answer);
	}		
	
	/* strings used to set the feedback and the check status of the radio buttons */
	var feedback = "";

	/* get the number of choices */
	numChoices = _oQuestion.choice.length;

	/* see if we have created the choices sequence for this question */
	if (_oQuestion.choiceRand == null) {
		/* we have not, create the array */
		_oQuestion.choiceRand = new Array();
		for (i=0; i<numChoices; i++)
			_oQuestion.choiceRand[i] = i + 1;

		/* see if we need to randomize the choices */
		if (randomizeChoices == true) {
			/* we do, randomize them */
			for (i=0; i<numChoices; i++) {
				var rand = Math.floor(Math.random()* numChoices);
				var temp = _oQuestion.choiceRand[i];
				_oQuestion.choiceRand[i] = _oQuestion.choiceRand[rand];
				_oQuestion.choiceRand[rand] = temp;
			}
		}
	}

	/* see if the learner has already provided an aswer */
	if (_oQuestion.response != "") {
		// he has, break the response into an array for later display
		aResponse = _oQuestion.response.split("[,]");
		
		/* there is an answer, see if this is the correct answer */
		if (_oQuestion.response == _oQuestion.answer) {
			/* it was, set the correct feedback */
			feedback = _oQuestion.feedbackCorrect;
		} else {
			/* wrong answer, set the incorrect feedback */
			feedback = _oQuestion.feedbackIncorrect;
		}
	}

	/* see if the learner has already hit the maximum number of tries */
	var bTooMany = (_oQuestion.attempts >= numberAttempts) ? true : false;
	if (bTooMany)
		var sData = XsMsgTooMany;
	else
		var sData = "";

	/* see if the learner has reached the time out */
	if (_bTimeLimitReached)
		sData += XsMsgTimeout;

	/* make sure we will disable the question for too many attempts or a timeout */
	bTooMany = bTooMany || _bTimeLimitReached;
	
	/* create arrays to hold the left and right side choices */
	var aLeft = new Array();
	var aRight = new Array();
	var aAlpha = new Array('A','B','C','D','E','F','G','H','I','J');
	for (i=0; i<numChoices; i++) {
		/* use the random array to decide which choice to create */
		var nChoice = _oQuestion.choiceRand[i] - 1;

		/* add the start of the text field */
		aLeft[i] = '<INPUT SIZE="1" MAXLENGTH="1"';

		/* see if we need to disable the edit controls */
		if (bTooMany) {
			aLeft[i] += 'disabled ';
		}

		/* add more of the text field */
		var nNum = nChoice + 1;
		aLeft[i] += 'type="text" name="answer' + nNum + '" value="';

		/* see if there were any responses */
		if (_oQuestion.response != "") {
			/* there were, add in the response from the number-answer pair */
			aLeft[i] += aResponse[i].split("[.]")[1];
		}

		/* add the rest of the text field */
		aLeft[i] += '">&nbsp;';

		/* add the choice */
		nNum = i + 1;
		aLeft[i] += nNum + '. ' + _oQuestion.list[i];
		aRight[i] = aAlpha[i] + '. ' + _oQuestion.choice[i];
	}

	/* put together the question */
	sData += getPageNumber() + _oQuestion.question;
	sData += '<FORM name=qform>';
	sData += '<table>';
	for (i=0; i<numChoices; i++) {
		sData += '<tr><td>';
		sData += aLeft[i];
		sData += '</td><td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;';
		sData += aRight[i];
		sData += '</td></tr>';
	}
	sData += '</table>';
	// decide if we need to show immediate feedback
	if (immediateFeedback) {
		// we do, show the check answer button
		sData += '<br /><INPUT class=check_button type=button value="' + XsMsgCheck + '" name=check';
		if (bTooMany)
			sData += ' disabled';
		sData += ' onclick=evalMatching(true)>';
	}
	sData += '</FORM><br />';
	
	// decide if we need to show immediate feedback
	if (immediateFeedback) {
		// we do, show the feedback
		sData += '<SPAN class=feedback id=feedback>' + feedback + '</SPAN>';
	}

	/* show it */
	document.getElementById("question").innerHTML = sData;

	/* set focus */
	if (!bTooMany) {
		tf = document.getElementsByName("answer1")[0];
		tf.focus();
		tf.focus();
	}
}

/***
* Evaluate a true-false question
***/
function evalTrueFalse(bDisplay) {
		//debugger;
	/* get the radio button array */
	rButtons = document.getElementsByName("answer");
	
	/* remember the previous answer */
	var sPrevAnswer = _oQuestion.response;

	/* remember which radio button has been selected */
	if (rButtons[0].checked == true) {
		/* selected true */
		_oQuestion.response = "t";
	} else if (rButtons[1].checked == true) {
		/* selected false */
		_oQuestion.response = "f";
	} else if (bDisplay) {
		// no selection and called from submit answer button, provide instructions
		alert(XsMsgDirectionsTF);
		return false;
	}
	
	// see if prev/next hit instead of submit AND this is the first answer AND there is a response
	if (!bDisplay && sPrevAnswer == "" && _oQuestion.response != "") {
		// it is, we will not report this interaction so return with false
		return false;
	} else {
		// this is a good answer, reset the previous answer to record it if the submit button was pressed
		if (bDisplay)
			sPrevAnswer = "";
		
		// turn off the warning
		_bSubmitWarning = false;
	}
	
	/* report the interaction to SCORM */
	reportInteraction(sPrevAnswer);
	
	/* redisplay the question */
	if (bDisplay) {
		showTrueFalse();
	}
	
	// learner responded so return true;
	return true;
}

/***
* Evaluate a multiple choice question
***/
function evalChoice(bDisplay) {
	/* remember the previous answer */
	var sPrevAnswer = _oQuestion.response;
	
	/* get the radio button array */
	var rButtons = document.getElementsByName("answer");

	/* remember which radio button has been selected */
	for (var i=0; i<rButtons.length; i++) {
		if (rButtons[i].checked == true) {
			/* radio button was selcted, get the value of this choice */
			_oQuestion.response = rButtons[i].value;
			break;
		}
	}

	// see if there was a selection AND called from submit
	if (_oQuestion.response == "" && bDisplay) {
		/* no selection, tell the learner to select an answer and then quit */
		alert(XsMsgDirectionsMC);
		return false;
	}
	
	// see if prev/next hit instead of submit AND this is the first answer AND there is a response
	if (!bDisplay && sPrevAnswer == "" && _oQuestion.response != "") {
		// it is, we will not report this interaction so return with false
		return false;
	} else {
		// this is a good answer, reset the previous answer to record it if the submit button was pressed
		if (bDisplay)
			sPrevAnswer = "";
		
		// turn off the warning
		_bSubmitWarning = false;
	}
	
	/* report the interaction to SCORM */
	reportInteraction(sPrevAnswer);

	/* redisplay the question */
	if (bDisplay) {
		showChoice();
	}
	
	// learner responded so return true;
	return true;
}

/***
* Evaluate a multiple choice with multiple answers question
***/
function evalChoiceMultiple(bDisplay) {
	/* remember the previous answer */
	var sPrevAnswer = _oQuestion.response;
	
	/* get the checkboxes array */
	var cButtons = document.getElementsByName("answer");

	/* remember which checkboxes have been selected */
	var aChecks = new Array();
	var nChecks = 0;
	for (var i=0; i<cButtons.length; i++) {
		if (cButtons[i].checked == true) {
			/* radio button was selcted, get the value of this choice */
			aChecks[nChecks] = cButtons[i].value - 0;
			nChecks++;
		}
	}

	/* see if we have any checks */
	if (aChecks.length > 0) {
		/* we do, sort the array and build the answer string */
		aChecks = aChecks.sort();
		_oQuestion.response = aChecks.join(',');
	} else {
		/* no checks, set the answer list to an empty string */
		_oQuestion.response = "";
	}

	// see if prev/next hit instead of submit AND this is the first answer AND there is a response
	if (!bDisplay && sPrevAnswer == "" && _oQuestion.response != "") {
		// it is, we will not report this interaction so return with false
		return false;
	} else {
		// this is a good answer, reset the previous answer to record it if the submit button was pressed
		if (bDisplay)
			sPrevAnswer = "";
		
		// turn off the warning
		_bSubmitWarning = false;
	}
	
	/* report the interaction to SCORM */
	reportInteraction(sPrevAnswer);

	/* redisplay the question */
	if (bDisplay) {
		showChoiceMultiple();
	}
	
	// learner responded so return true;
	return true;
}

/***
* Evaluate a fill-in question
***/
function evalFillIn(bDisplay) {
	/* remember the previous answer */
	var sPrevAnswer = _oQuestion.response;
	
	/* get the correct answer(s) and the number of required answers */
	var aCorrect = _oQuestion.answer.split(',');
	var nAnswers = aCorrect.length;

	/* get the learner input to the first edit field */
	_oQuestion.response = document.getElementsByName("answer1")[0].value;

	/* see if we need to get a second response */
	if (nAnswers > 1) {
		/* we do, get that one */
		_oQuestion.response += "," + document.getElementsByName("answer2")[0].value;
	}

	/* see if there was an any answer provided */
	if (_oQuestion.response == "" || _oQuestion.response == ",") {
		/* no answer, tell the learner to select an answer and then quit */
		needAnswer();
		tf = document.getElementsByName("answer1")[0];
		tf.focus();
		tf.focus();
		return false;
	}

	/* convert the values to lower case to avoid case comparison errors */
	_oQuestion.answer = _oQuestion.answer.toLowerCase();
	_oQuestion.response = _oQuestion.response.toLowerCase();

	/* redisplay the question */
	if (bDisplay) {
		showFillIn();
	}
	
	/* report the interaction to SCORM */
	reportInteraction(sPrevAnswer);
	
	// learner responded so return true;
	return true;
}

/***
*
* Evaluate a matching question
*
***/
function evalMatching(bDisplay) {
	/* remember the previous answer */
	var sPrevAnswer = _oQuestion.response;
	
	/* get the number of choices */
	var numChoices = _oQuestion.choice.length;

	/* create an array to get the responses */
	var aResponse = new Array();

	/* look through all of the answers */
	for (var i=0; i<numChoices; i++) {
		/* get the name of the text field */
		var nNum = i + 1;
		var sControl = "answer" + nNum;

		/* get the response in this text field and make it upper case */
		var sResponse = document.getElementsByName(sControl)[0].value.toUpperCase();

		/* see if it is blank */
		if (sResponse == "") {
			/* it is, tell the learner to select an answer and then quit */
			needAnswer();
			tf = document.getElementsByName("answer1")[0];
			tf.focus();
			tf.focus();
			return;
		}
        
		/* build the number-answer pair */
		aResponse[i] = nNum + "[.]" + sResponse;
		
	}

	/* put together all of the answers */
	_oQuestion.response = aResponse.join("[,]");

	/* redisplay the question */
	if (bDisplay) {
		showMatching();
	}
	
	/* report the interaction to SCORM */
	reportInteraction(sPrevAnswer);
	
	// learner responded so return true;
	return true;
}

/***
* warn the learner that he must provide an answer
***/
function needAnswer() {
	// see if we want to complain about a missing answer
	if (!mustAnswer) {
		// we do not
		return;
	}

	/* provide feedback based on the type of question */
	if (_oQuestion.type == "true-false")
		alert(XsMsgAnswerTF);
	else if (_oQuestion.type == "choice")
		alert(XsMsgAnswerMC);
	else if (_oQuestion.type == "choice-multiple")
		alert(XsMsgAnswerMCM);
	else if (_oQuestion.type == "fill-in")
		alert(XsMsgAnswerFI);
	else if (_oQuestion.type == "matching")
		alert(XsMsgAnswerM);
}

/***
* report the interaction through the SCORM API
*	sPrevAnswer - the previous answer to this question
***/
function reportInteraction(sPrevAnswer) {
	/* do not record the interaction if the previous response is the same as the new response */
	if (sPrevAnswer == _oQuestion.response)
		return;
	
	/* increment the number of attempts for this question */
	_oQuestion.attempts += 1;
	
	// adjust the type if needed
	if (_oQuestion.type == "choice-multiple")
		var sType = "choice";
	else
		var sType = _oQuestion.type;
	
	// get the result
	if (_oQuestion.response == _oQuestion.answer)
		var sResult = "correct";
	else
		var sResult = "incorrect";
		
	// fix true-false responses to work with SCORM 2004
	var sResponse = _oQuestion.response;
	var sAnswer = _oQuestion.answer;
	if (_oQuestion.type == "true-false") {
		if (sResponse == "f") sResponse = "false";
		if (sResponse == "t") sResponse = "true";
		if (sAnswer == "f") sAnswer = "false";
		if (sAnswer == "t") sAnswer = "true";
	}
		
	// set the interaction
	if (parent.setInteraction)
		parent.setInteraction(null,returnID(),sType,sResponse,sAnswer,sResult,"1",null,_oQuestion.question,null);
}

/***
* Return the ID of this question
***/
function returnID() {
	// see if the id property of the question is blank
	if (_oQuestion.id == "") {
		// it is, convert the question prompt to serve as the ID, escaped and max 255 characters
		return escape(_oQuestion.question).substring(0,254);
	}
	
	// return the ID
	return _oQuestion.id;
}

/* convert scorm 2004 time interval to milliseconds */
function ISODurationToMillisec(str) {
	var aV = new Array(0,0,0,0,0,0);
	var bErr = false;
	var bTFound = false;
	
	/* test to make sure there is a string */
	if(str == "")  {
		return "0";
	}

	if (str.indexOf("P") != 0) bErr = true;
	if (!bErr) {
		var aT = new Array("Y","M","D","H","M","S")
		var p=0, i=0;
		str = str.substr(1); //get past the P
		for (i = 0 ; i < aT.length; i++)
		{
		  if (str.indexOf("T") == 0)
		  {
			str = str.substr(1);
			i = Math.max(i,3);
			bTFound = true;
		  }
		  p = str.indexOf(aT[i]);
	
		  if (p > -1)
		  {
			// Is this a M before or after T?
			if ((i == 1) && (str.indexOf("T") > -1) && (str.indexOf("T") < p)) continue;
			if (aT[i] == "S")
			{
			  aV[i] = parseFloat(str.substr(0,p))
			}
			else
			{
			  aV[i] = parseInt(str.substr(0,p))
			}
			if (isNaN(aV[i]))
			{
			  bErr = true;
			  break;
			}
			else if ((i > 2) && (!bTFound))
			{
			  bErr = true;
			  break;
			}
			str = str.substr(p+1);
		  }
		}
    if ((!bErr) && (str.length != 0)) bErr = true;
    //alert(aV.toString())
  }
  
  if (bErr) {
    //alert("Bad format: " + str)
    return
  }
  
  return aV[0]*31557600000 + aV[1]*2629800000
    + aV[2]*86400000 + aV[3]*3600000 + aV[4]*60000
    + Math.round(aV[5]*1000)
}

/* Convert multiple choice answers from question.js format to Scorm 2004 format */
function answerTo2004(sAnswer) { 
	// split the answer into an array 
	var aNew = sAnswer.split(",");
	
	// loop through the new array
	for (var i=0; i<aNew.length; i++) {
		// replace - with [.]
		aNew[i] = aNew[i].split("-").join("[.]");
	}
	
	// join the array into a string using [,]
	return aNew.join("[,]");
}

// get the XML document from a file name
function getXmlDocument(sFile) {
	var xmlHttp, oXML;
	
	// try to use the native XML parser
	try {
		xmlHttp = new XMLHttpRequest();
		xmlHttp.open("GET", sFile, false); // Use syncronous communication
		xmlHttp.send(null);
		oXML = xmlHttp.responseXML;
	} catch(e) {
		// can't use the native parser, use the ActiveX instead
		xmlHttp = getXMLObject();
		xmlHttp.async = false;            // Use syncronous communication
		xmlHttp.resolveExternals = false;
		xmlHttp.load(sFile);
		oXML = xmlHttp;
	}
	
	// return the XML document object
	return oXML;
}

// get the best ActiveX object that can read XML
function getXMLObject() {
	// create an array with the XML ActiveX versions
	var aVersions = new Array("Msxml2.DOMDocument.6.0", "Msxml2.DOMDocument.3.0");
	
	// loop through the array until we can create an activeX control
	for (var i=0; i<aVersions.length; i++) {
		// return when we can create the activeX control
		try {
			var oXML = new ActiveXObject(aVersions[i]);
			return oXML;
		} catch(e) {
		}
	}
	
	// could not create an activeX, return a null
	return null;
}

/*
* Debug messages
*/
function debugMsg(sMessage) {
	/* see if the debug flag is set */
	if (_nDebug > 0) {
		/* it is, see if this message does not contain interaciton info */
		if (sMessage.indexOf("cmi.interactions") == -1) {
			/* it does not, show it */
			alert(sMessage);
		}
	}
}

// return true if we are in the main course page (not the test out)
function inMain(win) {
	// return true if the current page is Course.htm
	return win.location.href.indexOf("Course.htm") > -1;
}
// return true if we are in the main course page (not the test out)
function inResults(win) {
	// return true if the current page is Course.htm
	return win.location.href.indexOf("KCInit.htm") > -1;
}

// load in Language.xml which contains the language strings
function loadLanguage() {
	// see if we are running in course
	if (parent.getStoredLanguage) {
		// we do, get the language
		var sLanguage = parent.getStoredLanguage();
	} else {
		// we do not, use english
		var sLanguage = "en-us";
	}
	
	// load the XML file
	var oXML = getXmlDocument("../../Configuration/Language_" + sLanguage + ".xml");
	
	// get the assessment node
	var oAssessment = oXML.getElementsByTagName("assessment");
	
	// get the array of strings from the assessment node
	var oStrings = oAssessment[0].getElementsByTagName("string");
	
	// get the length of the string array
	var nLen = oStrings.length;
	
	// loop through the array of strings
	for (var i = 0; i<nLen; i++) {
		// load the data
		eval(oStrings[i].getAttribute("var") + " = \"" + oStrings[i].firstChild.data + "\"");
	}
}

// This function gets the total number of sections in the Knowledge Check that are not tested out
function getNonTestedOutQuestionTotal(){
	// Initialize the total to the number of objectives in case there is no test out here
	var nTotal = 0;
	
	// see if in post test
	if(parent._bPosttest){
		// total number of questions
		nTotal = _nQuestions;
		
		// see if we require passed objectives
		if(parent._sPT_RequirePassedObjectives)
			return nTotal;
			
	}else{
		// total number of sections
		nTotal =_nObjectives;
	}
	// see if we are in a KC and there was a pre test
	if(inMain(parent) && parent._bPretest && parent._bTestOut){
		// We are, so reset the total to 0
		nTotal = 0;
		// loop through the number of objectives
		for(var i=0; i < _nObjectives; i++){
			// see if each section was tested out
			if(_aTestedOutOrder[i] != -1){
				// see if this is the post test
				if(parent._bPosttest)
				// this section was not tested out and is a post test, so count every question in a non-tested out section
					nTotal += _aTotalQuestions[_aOrder[i]];
				else
				// this section was not tested out, so increment the total number of sections.
				nTotal++;
			}
		}
	}
	return nTotal;
}

// This function gets the total number of sections in the Knowledge Check that are not tested out
function getNonTestedOutObjectiveTotal(){
	// Initialize the total to the number of objectives in case there is no test out here
	var nTotal = _nObjectives;
	
	// see if we are in the post test and if we should include tested out objectives
	if(parent._bPosttest && parent._sPT_RequirePassedObjectives)
		// we are in post test and we don't want tested out questions shown
		return _nObjectives;
		
	// see if we are in a KC and there was a pre test
	if(inMain(parent) && parent._bPretest && parent._bTestOut){
		// We are, so reset the total to 0
		nTotal = 0;
		// loop through the number of objectives
		for(var i=0; i < _nObjectives; i++){
			// see if each section was tested out
			if(_aTestedOutOrder[i] != -1){
				// this section was not tested out, so increment the total number of sections.
				nTotal++;
			}
		}
	}
	return nTotal;
}

// This function gets the total number of sections in the Knowledge Check that are not tested out
function getLastNonTestedOutObjective(){
	// Initialize the total to the number of objectives in case there is no test out here
	var nLastObjective = _aOrder[_nObjectives-1];
	
	// see if we are in the post test and if we should include tested out objectives
	if(parent._bPosttest && parent._sPT_RequirePassedObjectives)
		// we are in post test and we don't want tested out questions shown
		return nLastObjective;
		
	// see if we are in a KC and there was a pre test
	if(inMain(parent) && parent._bPretest && parent._bTestOut){
		// loop through the number of objectives
		for(var i=0; i < _nObjectives; i++){
			// see if each section was tested out
			if(_aTestedOutOrder[i] != -1){
				// this section was not tested out, so increment the total number of sections.
				nLastObjective = _aOrder[i];
			}
		}
	}
	return nLastObjective;
}

// Adjusts the current question number to reflect removed tested out questions
function getNonTestedOutQuestionNumber(){
	var nCurrent = _nSectionCurrent+1;
	
	// see if we are in the post test and if we should include tested out objectives
	if(parent._bPosttest && parent._sPT_RequirePassedObjectives)
		// we are in post test and we don't want tested out questions shown
		return nCurrent;
		
	// see if we are in a KC and there was a pre test
	if(inMain(parent) && parent._bPretest && parent._bTestOut){
		// we are, loop through the number of objectives
		for(var i=_nSectionCurrent; i >= 0; i--){
			// see if each section was tested out
			if(_aTestedOutOrder[_aOrder[i]] == -1){
				// this section was tested out, so increment the actual current number lower.
				nCurrent--;
			}
		}
	}
	return nCurrent;
}

// This function increments the selection counter and makes sure it returns a non-tested out selection
function setNextSection(){
	_nSectionCurrent++;
	
	// see if we are in the post test and if we should include tested out objectives
	if(parent._bPosttest && parent._sPT_RequirePassedObjectives)
		// we are in post test and we don't want tested out questions shown
		return;
		
	// see if we are in a KC and there was a pre test
	if(inMain(parent) && parent._bPretest && parent._bTestOut){
		while(_nSectionCurrent < _nObjectives && _aTestedOutOrder[_nSectionCurrent] == -1)
			_nSectionCurrent++;
	}
	
}

// This function decreases the selection counter and makes sure it returns a non-tested out selection
function setPreviousSection(){
	_nSectionCurrent--;
	
	// see if we are in the post test and if we should include tested out objectives
	if(parent._bPosttest && parent._sPT_RequirePassedObjectives)
		// we are in post test and we don't want tested out questions shown
		return;
		
	// see if we are in a KC and there was a pre test
	if(inMain(parent) && parent._bPretest && parent._bTestOut){
		while(_nSectionCurrent >= 0 && _aTestedOutOrder[_nSectionCurrent] == -1)
			_nSectionCurrent--;	
	}
}

/*************************************************************
 *  POST TEST FUNCTIONS
 **************************************************************/
 // This function autocompletes the post test for the user by filling in all of the unanswered questions as incorrect and saving the data
 function autoCompletePosttest(){
 	
 	// loop through each section
 	for(var i=0; i < test.length; i++){
 		// loop through each pool in each section
 		for(var j=0; j < test[i].pool.length; j++){
 			// see if the question has not been attempted
 			if(test[i].pool[j].attempts == 0){
 				// it has not, so set an incorrect response and increment the question attempt
 				test[i].pool[j].response = '-1';
 				test[i].pool[j].attempts++;
 			}
 		}		
 	}
 	
 	var nScore = calcPosttest();
						
	// see if the learner has passed the test
	_sPassStatus = "I";
	if (nScore >= _nPassingScore){
		// set to passed
		_sPassStatus = "P";									
	}else if(parent._sPT_MaxAttempts > 0 && _nPosttestAttempts >= parent._sPT_MaxAttempts){
		_sPassStatus = "F";
	}

 	// save the state of the posttest
 	saveCurrentState();
 }
 
 
 // initialize question answers for questions that have been tested out.
 function initializeTestedOutQuestions(){
 	for(var j=0; j < test.length; j++){
		// get a reference to each section
		var currentTest = test[j];
	
		// see if this section has been tested out of
		if(parent._oObjectives.Item(currentTest.id).state == 1){
			
			// it has, so loop through each question and auto anser each correct
			for(var k=0; k < currentTest.pool.length; k++){
				// set the response to the correct answer
				currentTest.pool[k].response = currentTest.pool[k].answer;
				
				// set attempt to 1
				currentTest.pool[k].attempts = 1;
			}
		}
	}
 }